#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FileWin.h"
#include "FileMan.h"
#include "Global.h"
#include "pgpmail.h"
#include "mixmaster.h"
#include "cyberpunk.h"
#include "httpdlg.h"
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma link "explbtn"
#pragma resource "*.dfm"
TTextFileWin *TextFileWin;
//---------------------------------------------------------------------------
void __fastcall EditTextFile(AnsiString &FileName, TForm *Owner)
{
   AnsiString s,fn=FileName,
      ctyp1txt=MixDir()+CTyp1Txt,cringtxt=MixDir()+CRingTxt,
      mtyp2txt=MixDir()+MTyp2Txt;
   Application->MainForm->Cursor = crHourGlass;
   TStringList *lines = new TStringList();
   if (fn==cringtxt && HasPgp())
   {  // special handling of pubring.asc
      lines->LoadFromFile(fn);
      lines->SetText(PgpArmorBlockToArmorKeys(lines->Text.c_str()));
   }
   else
   if (fn==ctyp1txt && HasPgp())
   {  // special handling of type1.list
      lines->LoadFromFile(fn);
      if (lines->Count)
      {
         lines->Sorted = true;
         bool ok=false;
         for (int i=0; i<lines->Count; i++)
            if (lines->Strings[i].SubString(1,1)!="#")
               ok = true;
         lines->Sorted = false;
         if (ok) while (lines->Strings[0].SubString(1,1)=="#")
         {
            s = lines->Strings[0];
            lines->Delete(0);
            lines->Add(s);
         }
      }
   }
   else
   if (fn==mtyp2txt && HasMix())
   {  // special handling of type2.list
      lines->LoadFromFile(fn);
      if (lines->Count)
      {
         lines->Sorted = true;
         bool ok=false;
         for (int i=0; i<lines->Count; i++)
            if (lines->Strings[i].SubString(1,1)!="#")
               ok = true;
         lines->Sorted = false;
         if (ok) while (lines->Strings[0].SubString(1,1)=="#")
         {
            s = lines->Strings[0];
            lines->Delete(0);
            lines->Add(s);
         }
      }
   }

   if (fn==cringtxt || fn==ctyp1txt || fn==mtyp2txt) EditFileText(lines,fn);
   else TextFileWin = new TTextFileWin(fn,Owner);

   Application->MainForm->Cursor = crDefault;
   delete lines;
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::Save()
{
   AnsiString fn=filename,
      cringtxt=MixDir()+CRingTxt,clisttxt=MixDir()+CListTxt,ctyp1txt=MixDir()+CTyp1Txt,
      mringtxt=MixDir()+MRingTxt,mlisttxt=MixDir()+MListTxt,mtyp2txt=MixDir()+MTyp2Txt;
   int bakcopies=STATSBAKCOPIES;
   Application->MainForm->Cursor = crHourGlass;
   TStringList *lines = new TStringList();
   lines->Text = Editor->Lines->Text;
   // special handling of pubring.asc stats doc--convert to single block
   if (fn==cringtxt && HasPgp()) // needsPgp...very important
      lines->SetText(PgpArmorKeysToArmorBlock(lines->Text.c_str()));

   // save the document===============================
   if (fn==cringtxt || fn==clisttxt || fn==mringtxt || fn==mlisttxt)
      SaveToFileBak(lines,fn,bakcopies);
   else
      lines->SaveToFile(fn);
   //==========================

   // regenerate type1
   if ((fn==clisttxt || fn==cringtxt) && HasPgp()) // needs pgp
   {
      lines->Text = CpkGenType1();
      if (lines->Count) SaveToFileBak(lines,ctyp1txt,bakcopies);
   }
   // regenerate type2
   if ((fn==mlisttxt || fn==mringtxt) && HasMix())
   {
      lines->Text = MixGenType2();
      if (lines->Count) SaveToFileBak(lines,mtyp2txt,bakcopies);
   }
   // finished...
   Editor->Modified = false;
   Application->MainForm->Cursor = crDefault;
   delete lines;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall EditFileText(TStrings *Text, AnsiString &FileName, TForm *Owner)
{
   TextFileWin = new TTextFileWin(Text,FileName,Owner);
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TComponent* Owner)
  : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   EditWordWrapItem->Checked = false;
   filename = Filename;
   if (FileExists(filename))
   {
      TStringList *txt = new TStringList();
      txt->LoadFromFile(filename);
      SetText("...\\"+ExtractFileName(Filename),txt);
      delete txt;
   }
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TStrings *Txt, AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   EditWordWrapItem->Checked = false;
   filename = Filename;
   SetText(ExtractFileName(Filename),Txt);
   ActiveControl = Editor;
   Editor->SelStart = 0;
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::SaveAs()
{// not needed but placed for safety
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::SetText(AnsiString &Name, TStrings *Text)
{
//   IndexStr = Name;
//   DataKey = UserNotes+PS+Name;
   Caption = Name;
   Editor->OnSelectionChange = NULL;
   Editor->Lines->Text = Text->Text;
   Editor->Modified = false;
   Editor->SelStart = 0;
   Editor->OnSelectionChange = EditorSelectionChange;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      int reply = MsgBoxHwnd(Handle,
            ExtractFileName(filename).UpperCase()+" has been modified. Changes will be lost!\n\nSave it now?",
               "Save File",MB_YESNOCANCEL);
      switch(reply)
      {
         case IDCANCEL: ok = false; break;
         case IDYES: Save(); break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
