//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "HeadMan.h"
//#include "version.h"
#include "global.h"

THeaderManager *HeadMan;
//---------------------------------------------------------------------------
THeaderManager *GetHeadMan(TStrings *Message)
{
   THeaderManager *hm = new THeaderManager(Message);
   return hm;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::PopHeader()
{
   if (!Head->Count || Head->Strings[0].IsEmpty()) return "";
   // remove any partial headers (orphan folds)
   AnsiString fld,hdr=Head->Strings[0];
   while (Head->Count && (Head->Strings[0].Pos(" ")==1 ||
      Head->Strings[0].Pos("\t")==1 || Head->Strings[0].IsEmpty()))
         Head->Delete(0);
   // anything left...
   if (!Head->Count) return "";

   hdr = Head->Strings[0]; Head->Delete(0);
   while (Head->Count)
   {
      fld = Head->Strings[0];
      if ((fld.Pos(" ")!=1 && fld.Pos("\t")!=1) || fld.IsEmpty()) break;
      hdr += "\n"+fld;
      Head->Delete(0);
   }
   return hdr;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::HdrName(const AnsiString Header)
{
   AnsiString name;
   int pos = Header.Pos(": ");
   if (pos) name = Header.SubString(1,pos+1);
   return name;
}
//---------------------------------------------------------------------------
__fastcall THeaderManager::THeaderManager(TStrings *Message)
{
   if (Message)
      Last = Message->Count;
   Head = Message;
}
//---------------------------------------------------------------------------
__fastcall THeaderManager::~THeaderManager()
{
}
//---------------------------------------------------------------------------
int __fastcall THeaderManager::GetRecipients(TStrings *addresses, TStrings *Message)
{
   addresses->Clear();
   if (Message) Head = Message;
   GetAddresses(addresses,GetDat("To: "));
   GetAddresses(addresses,GetDat("Cc: "));
   GetAddresses(addresses,GetDat("Bcc: "));
   return addresses->Count;
}
//---------------------------------------------------------------------------
int __fastcall THeaderManager::GetRecipsFull(AnsiString &Header, TStrings *addresses,
   TStrings *Message)
{
   int pos,i=0;
   addresses->Clear();
   AnsiString addrs,addr;
   if (Message) Head = Message;

   addrs = GetDat(Header);
   if (addrs.SubString(addrs.Length(),1)==",") addrs.SetLength(addrs.Length()-1);
   while ((pos=addrs.Pos("\r"))>0) addrs.Delete(pos,1);
   while ((pos=addrs.Pos("\n"))>0) addrs.Delete(pos,1);
   while ((pos=addrs.Pos(" ,"))>0) addrs.Delete(pos,1);
   while ((pos=addrs.Pos(", "))>0) addrs.Delete(pos+1,1);
   while ((addr=GetParam(i++,addrs,","))!="") addresses->Add(addr);
   return addresses->Count;
}
//---------------------------------------------------------------------------
int __fastcall THeaderManager::GetAddresses(TStrings *addresses, AnsiString &fromLine, TStrings *Message)
{
   if (Message) Head = Message;
   int p=1;
   AnsiString s,buf(fromLine);
   while (p>0)
   {
      s = GetAddress(buf).Trim();
      if (!s.IsEmpty() && addresses->IndexOf(s)==-1)
         addresses->Add(s);

      p = buf.Pos(",");
      buf = buf.SubString(p+1,1024);

   };
   return (addresses->Count);
}
//---------------------------------------------------------------------------
int __fastcall THeaderManager::GetRemAddresses(TStrings *addresses, AnsiString &fromLine, TStrings *Message)
{
   if (Message) Head = Message;
   int p=1;
   AnsiString s,buf(fromLine);
   while (p>0)
   {
      s = GetAddress(buf).Trim();
      if (!s.IsEmpty() && addresses->IndexOf(s)==-1)
         addresses->Add(s);

      p = buf.Pos(s);
      buf = buf.SubString(p+s.Length()+1,256);
   };
   return (addresses->Count);
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::GetAddress(AnsiString &fromLine, TStrings *Message)
{
   if (Message) Head = Message;
   char *at;
   UINT f,l;
   AnsiString addr;
   char Terms[7] = { ' ', ',', '<', '>', '=', 10, 13 };

   char *tmp = new char[fromLine.Length()+1];
   strcpy(tmp,fromLine.c_str());
   at = strchr(tmp,'@');
   if (at)
   {
      l=f=at-tmp;
      while (f>0 && !strchr(Terms,tmp[f-1]))
         f--;
      while (l<strlen(tmp) && !strchr(Terms,tmp[l]))
         l++;
      tmp[l] = '\0';
      addr = &tmp[f];
   }
   delete tmp;
   return addr.Trim();
}
/*
AnsiString __fastcall THeaderManager::GetAddress(AnsiString &fromLine)
{
   int at,lst,fst,L;
   AnsiString addr,line(fromLine); L=line.Length();
   char Terms[7] = { ' ', ',', '<', '>', '=', 10, 13 };
   if ((at=line.Pos("@"))>1)
   {
      fst=at; while (fst>0 && !Terms.Pos(line.SubString(fst,1))) fst--;
      lst=at; while (lst<L && !Terms.Pos(line.SubString(lst,1))) lst++;
   }
   return line.SubString(fst,lst-fst).Trim();
}
*/
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::GetDomain(AnsiString &fromAddress, TStrings *Message)
{
   if (Message) Head = Message;
   int pos;
   AnsiString dom;
   if ((pos = fromAddress.Pos("@")) > 0)
      dom = fromAddress.SubString(pos+1,1024);
   return dom;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::GetDat(AnsiString &header, TStrings *Message)
{
   if (Message) Head = Message;
   AnsiString hdr = Get(header);
   return hdr.SubString(header.Length()+1,1024);
}
//---------------------------------------------------------------------------
int __fastcall THeaderManager::GetAttachments(TStrings *attachments, TStrings *Message)
{
   if (Message) Head = Message;
   AnsiString s;
   for (int i=0; i<Head->Count; i++)
   {
      if (s.Pos("Attachment: ")==1) attachments->Add(s);
      if ((s=Head->Strings[i])=="") break;
   }
   return attachments->Count;
}
//---------------------------------------------------------------------------
int __fastcall THeaderManager::IndexOf(AnsiString &header, TStrings *Message)
{
   if (Message) Head = Message;
   int idx=-1;
   AnsiString s;
   for (int i=0; i<Head->Count; i++)
   {
      if ((s=Head->Strings[i].SubString(1,header.Length()))=="") break;
      if (s.LowerCase()==header.LowerCase())
      {
         idx=i; break;
      }
   }
   return idx;
}
//---------------------------------------------------------------------------
#define LINESTART1(line) Head->Strings[line].SubString(1,1)
AnsiString __fastcall THeaderManager::Get(AnsiString &header, TStrings *Message)
{
   if (Message) Head = Message;
   int idx;
   AnsiString s,hdr;
   if ((idx = IndexOf(header)) >= 0)
   {
      hdr += Head->Strings[idx];
      while (++idx < Head->Count)
      {
         if (LINESTART1(idx) != " " && LINESTART1(idx) != "\t") break;
         hdr += "\r\n"+Head->Strings[idx];
      }
   }
   return hdr;
}
//---------------------------------------------------------------------------
#define LINESTART2(line) Head->Strings[line].SubString(1,1)
int __fastcall THeaderManager::Delete(AnsiString &header, TStrings *Message)
{
   if (Message) Head = Message;
   int idx;
   if ((idx = IndexOf(header)) >= 0)
   {
      Head->Delete(idx);
      while (idx < Head->Count)
      {
         if (LINESTART2(idx) != " " && LINESTART2(idx) != "\t") break;
         Head->Delete(idx);
      }
   }
   return idx;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::GetActualToDat(TStrings *Message)
{
   if (Message) Head = Message;
   AnsiString To,s;
   for (int i=0; i<Head->Count; i++) { s = Head->Strings[i].Trim();
      if (s.Pos("Request-Remailing-To: ")==1) To=s.SubString(23,255); else
      if (s.Pos("Anon-Post-To: ")==1) To=s.SubString(15,255); else
      if (s.Pos("Anon-To: ")==1) To=s.SubString(10,255); else
      if (s.Pos("Post-To: ")==1) To=s.SubString(10,255); else
      if (s.Pos("To: ")==1) To=s.SubString(5,255);
      if (!To.IsEmpty()) break;
   }
   return To;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::IndexString(TStrings* Message)
{
   //return datetime+" -> "+GetAddress(GetActualToDat())+" "+sub;
   int pos;
   if (Message) Head = Message;
   AnsiString datetime = FormatDateTime("yyyy-mm-dd hh:nn:ss ",Now());
   AnsiString sub = GetDat("Subject: ");
   while ((pos=sub.Pos("\r"))>0) sub.Delete(pos,1);
   while ((pos=sub.Pos("\n"))>0) sub.Delete(pos,1);
   if (sub.IsEmpty()) sub="Re:";
   return datetime+"->"+OutCode+"S"+FieldSep+GetAddress(GetActualToDat())+
      FieldSep+sub+FieldSep+AnsiString(Message->Text.Length());
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::InIndexString(TStrings* Message)
{
   int pos;
   if (Message) Head = Message;
   AnsiString datetime = FormatDateTime("yyyy-mm-dd hh:nn:ss ",Now());
   AnsiString sub = GetDat("Subject: ");
   while ((pos=sub.Pos("\r"))>0) sub.Delete(pos,1);
   while ((pos=sub.Pos("\n"))>0) sub.Delete(pos,1);
   if (sub.IsEmpty()) sub="Re:";
   return datetime+"<-"+InCode+"N"+FieldSep+GetAddress(GetDat("From: "))+FieldSep+sub+FieldSep+
      AnsiString(Message->Text.Length());
}
//---------------------------------------------------------------------------
void __fastcall THeaderManager::HereIs(TStrings *Message)
{
   Head = Message;
}
//---------------------------------------------------------------------------
bool __fastcall THeaderManager::Has(AnsiString &header, TStrings *Message)
{
   if (Message) Head = Message;
   return IndexOf(header)>=0;
}
//---------------------------------------------------------------------------
long __fastcall THeaderManager::Eoh()
{
   int i=-1; while(++i<Head->Count)
      if (Head->Strings[i].IsEmpty()) break;
   return i;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::Get4Reply(AnsiString &header)
{
   int p,i;
   AnsiString tmp;
   TStringList *hdr = new TStringList();

   if (header.Trim()=="References:")
   {
      hdr->Text = GetReferences(!AddDummyReference);
      if (!hdr->Text.IsEmpty()) hdr->Text = " "+hdr->Text;
      hdr->Add(" "+GetDat("Message-ID: "));
      hdr->Text = "References:"+hdr->Text;
   }
   else
   if (header.Trim()=="Newsgroups:")
   {
      tmp = "Newsgroups: "+GetNewsgroups();
      i=1; while (i<=tmp.Length())
      {
         if (tmp[i]==',') tmp.Insert("\n ",i+1);
         i++;
      }
      hdr->Text = tmp;
   }
   else
   if (header.Trim()=="To:")
   {
      tmp = GetDat("Reply-To: ");
      if (tmp.IsEmpty()) tmp = GetDat("From: ");
      if (GetAddress(tmp)=="Use-Author-Address-Header@[127.1]")
      {
         tmp = GetDat("Author-Address: ")+" ";
         if ((p=tmp.Pos(" <AT> "))>0) { tmp.Delete(p,6); tmp.Insert("@",p); }
         while ((p=tmp.Pos(" <DOT> "))>0) { tmp.Delete(p,7); tmp.Insert(".",p); }
      }
      if (!tmp.IsEmpty()) tmp = "To: "+tmp;
      hdr->Text = tmp;
   }
   else
   if (header.Trim()=="Subject:")
   {
      tmp = GetDat("Subject: ");
      hdr->Text =  "Subject: "+
         (tmp.LowerCase().Pos("re: ")==1 ? tmp : "Re: "+tmp);
   }
   AnsiString Hdr = hdr->Text;
   delete hdr;
   return Hdr;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::GetReferences(bool AddDummy)
{
   int pos;
   AnsiString mid=GetDat("Message-ID: "),refs=GetDat("References: ").Trim();
   if (!refs.IsEmpty())
   {
      while ((pos=refs.Pos("\t"))>0) refs.Delete(pos,1);
      while ((pos=refs.Pos("\r"))>0) refs.Delete(pos,1);
      while ((pos=refs.Pos("\n"))>0) refs.Delete(pos,1);
      while ((pos=refs.Pos(" <"))>0) refs.Delete(pos,1);
      while ((pos=refs.Pos("> "))>0) refs.Delete(pos+1,1);
      while ((pos=refs.Pos("><"))>0) refs.Insert("\n ",pos+1);
      TStringList *REFS = new TStringList();
      REFS->Text = refs; // need REFS because refs is string not stringlist
      if (AddDummy && HeadMan->Has("Chain: ",Head) && REFS->Count>1)
         refs += "\n <>";
      delete REFS;
   }
   return refs;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THeaderManager::GetNewsgroups()
{
   int pos;
   AnsiString grps = GetDat("Followup-To: ").Trim();
   if (grps.IsEmpty()) grps = GetDat("Newsgroups: ").Trim();

   while ((pos=grps.Pos("\t"))>0) grps.Delete(pos,1);
   while ((pos=grps.Pos("\r"))>0) grps.Delete(pos,1);
   while ((pos=grps.Pos("\n"))>0) grps.Delete(pos,1);
   while ((pos=grps.Pos(" ,"))>0) grps.Delete(pos,1);
   while ((pos=grps.Pos(", "))>0) grps.Delete(pos+1,1);

   return grps;
}
//---------------------------------------------------------------------------

