#define _WINSOCKAPI_      // Prevent winsock.h from being included
#include <vcl\vcl.h>
#pragma hdrstop

#include "HttpDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "UrlsDlg.h"
#include "Mixmaster.h"
#include "Cyberpunk.h"
#include "PgpMail.h"
#include "HelpDlg.h"
//---------------------------------------------------------------------------
#pragma link "HttpProt"
#pragma link "explbtn"
#pragma resource "*.dfm"
THttpForm *HttpForm;
AnsiString httpretval;
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *owner, bool attended)
{
   HttpForm = new THttpForm(owner);
   CenterDialog(HttpForm,owner);
   bool ok = HttpForm->Execute(attended);
   delete HttpForm;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall THttpForm::THttpForm(TComponent* Owner)
    : TForm(Owner)
{
   DocMemo->Font->Name = GetAppIni("FontName","Courier New");
   DocMemo->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   ErrorCheck->Checked = GetAppIni(StatsErrCheck,"").ToIntDef(1);
   CenterDialog(this);
   PageControl1->ActivePage = TabSheet1;
   Label1->Caption = "";

   LoadHttpInfo();
   HttpCli1->RcvdStream = NULL;
   Tabs = TabSet->Tabs;
   CancelAnyway = false;
   Cancelled = false;
   Attended = false;
}
//---------------------------------------------------------------------------
__fastcall THttpForm::~THttpForm()
{
   for (int i=0; i<Tabs->Count; i++)
      delete (TStringList*)Tabs->Objects[i];
   delete HttpCli1->RcvdStream;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::SaveStatsHasProblems()
{
   SaveStatistics();
   if (MListBox->Checked || MRingBox->Checked)
   {
      if (MixType2HasDoubles() || MixListHasKeyNotFound())
         return false;
   }
   if (CListBox->Checked || CRingBox->Checked)
   {
      if (CpkType1HasDoubles() || CpkListHasKeyNotFound())
         return false;
   }
   return true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   SetTab(TabSet->TabIndex);
   if (ModalResult==mrOk && GoodTabs())
   {
      if (SaveStatsHasProblems())
      {
         Cancelled = true;
         CanClose = false;
      }
   }
   else if (Attended && ModalResult==mrCancel && GoodTabs())
   {
      switch(MsgBoxHwnd(Handle,
         "Your new remailer docs are not saved!\n\nSave them now?",
         "Remailer Documents",MB_YESNOCANCEL))
      {
         case ID_CANCEL: CanClose = false; break;
         case ID_YES:
            if (SaveStatsHasProblems())
            {
               Cancelled = true;
               CanClose = false;
               break;
            }
            ModalResult = mrOk;
            break;
      }
   }
   if (!CanClose) return;

   if (CancelAnyway) ModalResult = mrCancel;
   PutAppIni(StatsErrCheck,ErrorCheck->Checked ? "1":"0");
   StoreHttpInfo();
}
//---------------------------------------------------------------------------
TStrings* _fastcall THttpForm::TabDoc(int Index)
{
   // returns doc from tab or null if corrupt
   TStrings *Doc = dynamic_cast<TStrings*>(Tabs->Objects[Index]);
   if (Doc && Doc->Count && Doc->Text.Pos(CorruptReport)==1)
      Doc = NULL;
   return Doc;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SaveStatistics()
{
   TStrings *TxtList;
   int i,bakcopies=STATSBAKCOPIES;
   AnsiString TxtFile,mtyp2txt=MixDir()+MTyp2Txt,ctyp1txt=MixDir()+CTyp1Txt;
   // copy current docmemo to tab stringlist to get possible edits
   SetTab(TabSet->TabIndex);
   // process tabs
   for (i=0; i<Tabs->Count; i++)
   {
      if ((TxtFile=Tabs->Strings[i])=="Error" || (TxtList=TabDoc(i))==NULL)
         continue;

      if (ErrorCheck->Checked)
      {
         // special for pubring.mix doc
         if (TxtFile==MRingTxt && HasMix())
            TxtList->Text = MixAddNewRemailerKeys(TxtList);
         // special for pubring.asc
         if (TxtFile==CRingTxt && HasPgp())
         {
            TxtList->Text = CpkAddNewRemailerKeys(TxtList);
         }
      }

      //==Save Statistics======================================
      SaveToFileBak(TxtList,MixDir()+TxtFile,bakcopies);
      //=======================================================

      if (ErrorCheck->Checked)
      {
         TStringList *typelist = new TStringList();
         if ((TxtFile==MRingTxt || TxtFile==MListTxt) && HasMix())
         {
            typelist->Text = MixGenType2();
            SaveToFileBak(typelist,MixDir()+MTyp2Txt,bakcopies);
         }
         if ((TxtFile==CRingTxt || TxtFile==CListTxt) && HasPgp())
         {
            typelist->Text = CpkGenType1();
            SaveToFileBak(typelist,MixDir()+CTyp1Txt,bakcopies);
         }
         delete typelist;
      }
   }
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixType2HasDoubles()
{
  bool ok=false;
  TStringList *dbls = new TStringList();
  dbls->Text = MixType2Doubles();
  if (dbls->Count)
  {
     TStringList *msg = new TStringList();
     msg->Add("===================================Problem MIX Keys===================================\n");
     msg->Add("The following keys on your mixmaster keyring appear more than once. This would indicate the remailer");
     msg->Add("has probably changed configuration. You will need to determine which is current, and disable the older");
     msg->Add("key. To disable a key, put a '#' in front of the key's entry in 'type2.list'. This tells Mix and QS to ignore");
     msg->Add("the key in the future.\n");
     msg->Add("I'm sorry I cannot determine this for you, because the new key you have downloaded may actually be the");
     msg->Add("older of the duplicates. This can happen because not all stats/keys sources provide up to date keys. Take");
     msg->Add("a good look at them here. The proper choice may be evident. Then open type2.list (click 'View|type2.list'");
     msg->Add("on the QS main menu) and disable that key. Otherwise, disable BOTH until you can confirm which is");
     msg->Add("correct.\n\n");
     msg->Add(dbls->Text+"\n \n");
     MsgBox(msg->Text,"Mixmaster",MB_OK);
     delete msg;
     ok = true;
  }
  delete dbls;
  return ok;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkType1HasDoubles()
{
  bool ok=false;
  TStringList *dbls = new TStringList();
  dbls->Text = CpkType1Doubles();
  if (dbls->Count)
  {
     TStringList *msg = new TStringList();
     msg->Add("===================================Problem PGP Keys===================================\n");
     msg->Add("The following keys on your remailer keyring appear more than once. This would indicate the remailer");
     msg->Add("has probably changed configuration. You will need to determine which is current, and disable the older");
     msg->Add("key. To disable a key, put a '#' in front of the key's entry in 'type1.list'. This tells (Mix)PGP and QS to ignore");
     msg->Add("the key in the future.\n");
     msg->Add("I'm sorry I cannot determine this for you, because the new key you have downloaded may actually be the");
     msg->Add("older of the duplicates. This can happen because not all stats/keys sources provide up to date keys. Take");
     msg->Add("a good look at them here. The proper choice may be evident. Then open type1.list (click 'View|type1.list'");
     msg->Add("on the QS main menu) and disable that key. Otherwise, disable BOTH until you can confirm which is");
     msg->Add("correct.\n\n");
     msg->Add(dbls->Text+"\n \n");
     MsgBox(msg->Text,"Mixmaster",MB_OK);
     delete msg;
     ok = true;
  }
  delete dbls;
  return ok;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixListHasKeyNotFound()
{
   TStringList *nokeys = new TStringList();
   nokeys->Text = MixListKeyNotFound();
   if (nokeys->Count)
   {
      MsgBox(
         s("=================SOME MIX KEYS NOT FOUND=================\n")+
         s("\nYou have ")+s(nokeys->Count)+s(" remailer(s) in your type2.list file that you do not have MIX key(s)\n")+
         s("for. Please have a look. You've got 3 options in dealing with this.\n\n")+
         s("1) If you update your pubring.mix from the same source as your current\n")+
         s("mlist.txt, you will more than likely get that key. 2) You can leave them 'as is'.\n")+
         s("They won't be used, until a key is found, but I'll nag you with this dialog,\n")+
         s("after updates. 3) You can disable them with a pound sign '#' in front of those\n")+
         s("remailers in the type2.list file. In that case, I won't nag you, but I won't add\n")+
         s("those new keys when I find them, either.\n \n \n")+
         nokeys->Text+s("\n \n \n"),
         "TYPE2.LIST",
         MB_OK
      );
   }
   delete nokeys;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkListHasKeyNotFound()
{
   TStringList *nokeys = new TStringList();
   nokeys->Text = CpkListKeyNotFound();
   if (nokeys->Count)
   {
      MsgBox(
         s("=================SOME PGP KEYS NOT FOUND=================\n")+
         s("\nYou have ")+s(nokeys->Count)+s(" remailers in your type1.list file that you do not have PGP keys\n")+
         s("for. Please have a look. You've got 3 options.\n\n")+
         s("1) If you updated your pubring.asc from the same source as your current\n")+
         s("rlist.txt, you will more than likely get that key. 2) You can leave them 'as is'.\n")+
         s("They won't be used, until a key is found, but I'll nag you with this dialog,\n")+
         s("after updates. 3) You can disable them with a pound sign '#' in front of those\n")+
         s("remailers in the type1.list file. In that case, I won't nag you, but I won't add\n")+
         s("those new keys when I find them, either.\n \n \n")+
         nokeys->Text+s("\n \n \n"),
         "TYPE1.LIST",
         MB_OK
      );
   }
   delete nokeys;
   return true;
}
//---------------------------------------------------------------------------
int __fastcall THttpForm::GoodTabs()
{
   int valtabs=0;
   for (int i=0; i<Tabs->Count; i++)
   {
      TStrings *doc = dynamic_cast<TStrings*>(Tabs->Objects[i]);
      if (doc && doc->Count && doc->Text.Pos(CorruptReport)==1) continue;
      if (Tabs->Strings[i]=="Error") continue;
      valtabs++;
   }
   return valtabs;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SetTab(int TabIndex)
{
   if (TabSet->TabIndex>=0) // make sure tabdoc = docmemo
   {
      TStrings *tabdoc = dynamic_cast<TStrings*>(Tabs->Objects[TabSet->TabIndex]);
      if (tabdoc) tabdoc->Text = DocMemo->Lines->Text;
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;
   GetBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormShow(TObject *Sender)
{
   GetAppURLs();
   ActiveControl = Panel2;
   if (!Attended)
   {
      PageControl1->ActivePage = TabSheet3;
      Application->ProcessMessages();
      Timer2->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetBtnClick(TObject *Sender)
{
   if (Cancelled)
   {
      ResetCheckboxes();
      return;
   }

   if (!Timer1->Enabled) Timer1->Enabled = true;
   if (GetBtn->Enabled && GetBtn->Caption=="Get Docs")
   {
      TabSheet1->Enabled = false;
      TabSheet2->Enabled = false;
   }
   GetBtn->Enabled = false;
   OkBtn->Enabled = false;

   if (MListBox->Enabled && MListBox->Checked)
      GetStatistics(MListURL,MListBox,MListTxt);
   else
   if (MRingBox->Enabled && MRingBox->Checked)
      GetStatistics(MRingURL,MRingBox,MRingTxt);
   else
   if (MTyp2Box->Enabled && MTyp2Box->Checked)
      GetStatistics(MTyp2URL,MTyp2Box,MTyp2Txt);
   else
   if (CListBox->Enabled && CListBox->Checked)
      GetStatistics(CListURL,CListBox,CListTxt);
   else
   if (CRingBox->Enabled && CRingBox->Checked)
      GetStatistics(CRingURL,CRingBox,CRingTxt);
   else
   {
      ResetCheckboxes();
      ProgressBar1->Visible = false;
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      PageControl1->ActivePage = TabSheet3;

      if (ErrorCheck->Checked)
      {
         bool ok1=true,ok2=true,ok3=true,ok4=true;
         for (int i=0; i<Tabs->Count; i++)
         {
            TStringList *doc = dynamic_cast<TStringList*>(Tabs->Objects[i]);
            if (doc)
            {
               if (Tabs->Strings[i]==MListTxt) ok1=MixListOk(doc); else
               if (Tabs->Strings[i]==MRingTxt) ok2=MixRingOk(doc); else
               if (Tabs->Strings[i]==CListTxt) ok3=CListOk(doc); else
               if (Tabs->Strings[i]==CRingTxt) ok4=CRingOk(doc);
            }
         }
         if (!ok1 || !ok2 || !ok3 || !ok4)
         {
            CancelAnyway = true;
            Cancelled = true;
            Attended = true;
            GetBtn->Click();
         }
      }

      ActiveControl = DocMemo;
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      UrlsBtn->Enabled = true;
      OkBtn->Enabled = true;
      Label1->Caption = "";
      Cancelled = false;

      if (Attended) MyBeep(MB_OK);
      else
      {
         ProgressBar1->Visible = false;
         CancelBtn->Enabled = false;
         OkBtn->Enabled = false;
         SaveStatistics();        // could have gotten valid page before cancel
         if (MixType2HasDoubles()) Cancelled = true;
         Sleep(1000);
         ModalResult = !Cancelled || (Cancelled && TabSet->Tabs->Count>1) ?
            mrOk : mrCancel;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString KeyRingCnt(int val)
{
   AnsiString v=AnsiString(val);
   if (v.Length()<2) v = " "+v; return v;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CRingOk(TStrings *Doc)
{
   int beg=0,end=0;
   for (int i=0; i<Doc->Count; i++)
   {
      AnsiString line=Doc->Strings[i].Trim();
      if (line=="-----BEGIN PGP PUBLIC KEY BLOCK-----") beg++; else
      if (line=="-----END PGP PUBLIC KEY BLOCK-----") end++;
   }
   if (!beg || !end || beg!=end)
   {
      TabSet->TabIndex = Tabs->IndexOf(MRingTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'pubring.asc' document appears corrupt. By my\n")+
         s("count there are:\n\n")+
         s(" "+KeyRingCnt(beg)+" Begin Pgp Public Key block lines\n")+
         s(" "+KeyRingCnt(end)+" End Pgp Public Key lines\n\n")+
         s("These values should BOTH be greater than 0 and equal.\n")+
         s("In most cases there will be 1 of each--that is, a single\n")+
         s("large key block containing all the cpunk keys. A few key\n")+
         s("sources provide these keys as a series of individual key\n")+
         s("blocks.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MRingTxt.LowerCase(),
         MB_OK);
      return false;
   }
   if (!HasPgp()) return true;

   TStringList *newkeys = new TStringList();
   newkeys->Text = CpkGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   // notify of new keys, if any
   if (newkeys->Count)
   {
      TStringList *msg = new TStringList();
      AnsiString s = newkeys->Count==1 ? "" : "s";
      TabSet->TabIndex = Tabs->IndexOf(CRingTxt);
      AppProcessMessages(); Sleep(300);
      msg->Add("====================NEW CYBERPUNK KEYS====================");
      msg->Add("\nThe following new key"+s+" will be added to your Cyberpunk keyring.\n");
      for (int i=0; i<newkeys->Count; i++)
      {
         AnsiString descrip="";
         for (int f=0; f<5; f++)
             if (f!=2) descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
         msg->Add(newkeys->Strings[i]);
      }
      msg->Add("\nAny remaining keys in this document will be discarded. \n \n \n");// since you already");
      //msg->Add("have them or don't want them.\n \n \n");
      MsgBoxHwnd(Handle,msg->Text,CRingTxt.LowerCase(),MB_OK);
      delete msg;
   }
   delete newkeys;
   return true;
}
//---------------------------------------------------------------------------
/*bool __fastcall THttpForm::CRingOk(TStrings *Doc)
{
   int beg=0,end=0;
   for (int i=0; i<Doc->Count; i++)
   {
      AnsiString line=Doc->Strings[i].Trim();
      if (line=="-----BEGIN PGP PUBLIC KEY BLOCK-----") beg++; else
      if (line=="-----END PGP PUBLIC KEY BLOCK-----") end++;
   }
   if (!beg || !end || beg!=end)
   bool ok1=Doc->IndexOf("-----BEGIN PGP PUBLIC KEY BLOCK-----")>=0;
   bool ok2=Doc->IndexOf("-----END PGP PUBLIC KEY BLOCK-----")>=0;
   if (!ok1 || !ok2)
   {
      AnsiString badline;
      if (!ok1 && !ok2)
         badline = "both first and last lines are"; else
      if (!ok1) badline = "the first line is"; else
      if (!ok2) badline = "the last line is";
      TabSet->TabIndex = Tabs->IndexOf(CRingTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n\n")+
         s("This 'pubring.asc' document appears corrupt. The first line\n")+
         s("should be:\n\n")+
         s("  \"-----BEGIN PGP PUBLIC KEY BLOCK-----\"\n\n")+
         s("and the last line:\n\n")+
         s("  \"-----END PGP PUBLIC KEY BLOCK-----\"\n\n")+
         s("In this document, "+badline+" not correct.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         CRingTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   if (!HasPgp()) return true;

   TStringList *newkeys = new TStringList();
   newkeys->Text = CpkGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   // notify of new keys, if any
   if (newkeys->Count)
   {
      TStringList *msg = new TStringList();
      AnsiString s = newkeys->Count==1 ? "" : "s";
      TabSet->TabIndex = Tabs->IndexOf(CRingTxt);
      AppProcessMessages(); Sleep(300);
      msg->Add("====================NEW CYBERPUNK KEYS====================");
      msg->Add("\nThe following new key"+s+" will be added to your Cyberpunk keyring.\n");
      for (int i=0; i<newkeys->Count; i++)
      {
         AnsiString descrip="";
         for (int f=0; f<5; f++)
             if (f!=2) descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
         msg->Add(newkeys->Strings[i]);
      }
      msg->Add("\nAny remaining keys in this document will be discarded. \n \n \n");// since you already");
      //msg->Add("have them or don't want them.\n \n \n");
      MsgBoxHwnd(Handle,msg->Text,CRingTxt.LowerCase(),MB_OK);
      delete msg;
   }
   delete newkeys;
   return true;
}*/
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CListOk(TStrings *Doc)
{
   AnsiString statsheader =
      s("remailer  email address                        history  latency  uptime\r\n")+
      s("-----------------------------------------------------------------------\r\n");
   int i,pos;
   while ((pos=Doc->Text.Pos("&lt;"))>0) Doc->Text.Delete(pos,4);
   while ((pos=Doc->Text.Pos("&gt;"))>0) Doc->Text.Delete(pos,4);
   if (Doc->Text.Pos(statsheader)==0)
   {
      TabSet->TabIndex = Tabs->IndexOf(CListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(100);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'rlist.txt' document appears corrupt. I'm unable to\n")+
         s("locate the statistics column headings. They should look\n")+
         s("like this:\n\n")+
         s("\"remailer  email address                        history  latency  uptime\"\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         CListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   int c=0;
   for (i=0; i<Doc->Count; i++)
      if (CpkListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      TabSet->TabIndex = Tabs->IndexOf(CListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'rlist.txt' document appears corrupt. I've located\n")+
         s("the stats column headers, but found no actual stats lines\n")+
         s("at all.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         CListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixListOk(TStrings *Doc)
{
   AnsiString statsheader =
      s("mixmaster           history  latency  uptime\r\n")+
      s("--------------------------------------------\r\n");
   if (Doc->Text.Pos(statsheader)==0)
   {
      TabSet->TabIndex = Tabs->IndexOf(MListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(100);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'mlist.txt' document appears corrupt. I'm unable to\n")+
         s("locate the statistics column headings. They should look\n")+
         s("like this:\n\n")+
         s("\"mixmaster           history  latency  uptime\"\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   int c=0;
   for (int i=0; i<Doc->Count; i++)
      if (MixListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      TabSet->TabIndex = Tabs->IndexOf(MListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'mlist.txt' document appears corrupt. I've located\n")+
         s("the stats column headers, but found no actual stats lines\n")+
         s("at all.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixRingOk(TStrings *Doc)
{
   int i,beg=0,end=0;
   AnsiString line,descrip,s;
   TStringList *des = new TStringList();
   for (i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      if (line=="-----Begin Mix Key-----") beg++; else
      if (line=="-----End Mix Key-----") end++; else
      if (MixRingLineOk(line))
         des->Add(line);
   }
   if (!(des->Count>0 && des->Count==beg && beg==end))
   {
      TabSet->TabIndex = Tabs->IndexOf(MRingTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'pubring.mix' document appears corrupt. By my\n")+
         s("count there are:\n\n")+
         s(" "+KeyRingCnt(des->Count)+" Mix key description lines\n")+
         s(" "+KeyRingCnt(beg)+" Begin Mix Key lines\n")+
         s(" "+KeyRingCnt(end)+" End Mix Key lines\n\n")+
         s("These values should ALL be greater than 0 and equal.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MRingTxt.LowerCase(),
         MB_OK);
       delete des;
      return false;
   }
   delete des;

   // doc is ok, check for new keys
   TStringList *newkeys = new TStringList();
   newkeys->Text = MixGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   // notify of new keys, if any
   if (newkeys->Count)
   {
      TStringList *msg = new TStringList();
      s = newkeys->Count==1 ? "" : "s";
      TabSet->TabIndex = Tabs->IndexOf(MRingTxt);
      AppProcessMessages(); Sleep(300);
      msg->Add("===============NEW MIXMASTER KEYS==============");
      msg->Add("\nThe following new key"+s+" will be added to your Mixmaster keyring.\n");
      for (i=0; i<newkeys->Count; i++)
      {
         descrip = "";
         for (int f=0; f<5; f++)
             if (f!=2) descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
         msg->Add(descrip.Trim());
      }
      msg->Add("\nAny remaining keys in this document will be discarded. \n \n \n");
      //, since you already have them or don't want");
      //msg->Add("them.\n \n \n");
      MsgBoxHwnd(Handle,msg->Text,MRingTxt.LowerCase(),MB_OK);
      delete msg;
   }
   delete newkeys;
   return true;
}
//---------------------------------------------------------------------------
/*bool __fastcall THttpForm::PgpKeyringHasDoubles()
{

  TStringList *dbls = new TStringList();
  dbls->SetText(CpkType2Doubles());
  if (!dbls->Count)
  {
     delete dbls; return false;
  }
  TStringList *msg = new TStringList();
  msg->Add("===================================Problem PGP Keys===================================\n");
  msg->Add("The following keys on your remailer keyring appear more than once. This would indicate the remailer");
  msg->Add("has probably changed configuration. You will need to determine which is current, and disable the older");
  msg->Add("key. To disable a key, put a '#' in front of the key's entry in 'type1.list'. This tells (Mix)PGP and QS to ignore");
  msg->Add("the key in the future.\n");
  msg->Add("I'm sorry I cannot determine this for you, because the new key you have downloaded may actually be the");
  msg->Add("older of the duplicates. This can happen because not all stats/keys sources provide up to date keys. Take");
  msg->Add("a good look at them here. The proper choice may be evident. Then open type1.list (click 'View|type1.list'");
  msg->Add("on the QS main menu) and disable that key. Otherwise, disable BOTH until you can confirm which is");
  msg->Add("correct.\n\n");
  TStringList *type1 = new TStringList();
  if (FileExists(MixDir()+CTyp1Txt)) type1->LoadFromFile(MixDir()+CTyp1Txt);
  for (int i=0; i<dbls->Count; i++)
  {
     for (int c=0; c<type1->Count; c++)
     {
        if (type1->Strings[c].Pos(dbls->Strings[i])>0)
        {
           AnsiString line = "";
           for (int p=0; p<3; p++)
              line += " "+GetParam(p,type1->Strings[c]," ");
           msg->Add(line.TrimLeft());
        }
     }
     msg->Add("");
  }
  msg->Add(" \n \n");
  MsgBox(msg->Text,"Cyberpunk",MB_OK);
  delete type1;
  delete msg;
  delete dbls;
  return true;
}*/
//---------------------------------------------------------------------------
bool __fastcall THttpForm::GetStatistics(AnsiString &forURL, TCheckBox *Box,
   AnsiString &Doc)
{
   CurDoc = Doc;
   CurBox = Box;
   Cap = forURL;//+"...";
   Label1->Caption = Cap;
   //CancelBtn->Caption = "Cancel";
   HttpCli1->URL = forURL;
   HttpCli1->Proxy = ProxyHostEdit->Text;
   HttpCli1->ProxyPort = ProxyPortEdit->Text;
   HttpCli1->ProxyUsername = ProxyUserEdit->Text;
   HttpCli1->ProxyPassword = ProxyPswdEdit->Text;
   HttpCli1->ModifiedSince = 0;
   ProgressBar1->Position = 0;
   ProgressBar1->Visible = true;
   BytesReceived = 0;

   try {
       HttpCli1->HeadASync();
   } __except (TRUE) {
       GetBtn->Enabled = true; //SetButtonState(true);
       TabSheet1->Enabled = true;
       TabSheet2->Enabled = true;

       DocMemo->Clear();
       DocMemo->Lines->Add("Head Failed !");
       DocMemo->Lines->Add("Status = " + IntToStr(HttpCli1->StatusCode));
       DocMemo->Lines->Add("Reason = " + HttpCli1->ReasonPhrase);
       PageControl1->ActivePage = TabSheet3;
       ProgressBar1->Visible = false;
       return false;
   }
   return !Cancelled;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::LoadHttpInfo()
{
   TStringList *http = new TStringList();
   if (AppDataExists(HttpInfo,http))
   {
      MListBox->Checked = http->Values["MListChkd"] == "1";
      MRingBox->Checked = http->Values["MRingChkd"] == "1";
      MTyp2Box->Checked = http->Values["MTyp2Chkd"] == "1";
      CListBox->Checked = http->Values["CListChkd"] == "1";
      CRingBox->Checked = http->Values["CRingChkd"] == "1";
      ProxyHostEdit->Text = http->Values["ProxyHost"];
      ProxyPortEdit->Text = http->Values["ProxyPort"];
      ProxyPswdEdit->Text = http->Values["ProxyPswd"];
      ProxyUserEdit->Text = http->Values["ProxyUser"];
   }
   Http = http->Text; // keep for later compare to see if modified
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::StoreHttpInfo()
{
   TStringList *http = new TStringList();
   http->Add("MListChkd="+AnsiString(MListBox->Checked?"1":"0"));
   http->Add("MRingChkd="+AnsiString(MRingBox->Checked?"1":"0"));
   http->Add("MTyp2Chkd="+AnsiString(MTyp2Box->Checked?"1":"0"));
   http->Add("CListChkd="+AnsiString(CListBox->Checked?"1":"0"));
   http->Add("CRingChkd="+AnsiString(CRingBox->Checked?"1":"0"));
   http->Add("ProxyHost="+ProxyHostEdit->Text);
   http->Add("ProxyPort="+ProxyPortEdit->Text);
   http->Add("ProxyPswd="+ProxyPswdEdit->Text);
   http->Add("ProxyUser="+ProxyUserEdit->Text);
   if (Http!=http->Text) // test for modified
      PutAppData(HttpInfo,http);
   delete http;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::Execute(bool attended)
{
   Attended = attended; ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
//void __fastcall THttpForm::SetButtonState(bool enabled)
//{
//   GetBtn->Enabled = enabled;
//}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ResetCheckboxes()
{
   Timer1->Enabled = false;
   if (MListBox->Checked) MListBox->Enabled = true;
   if (MRingBox->Checked) MRingBox->Enabled = true;
   if (MTyp2Box->Checked) MTyp2Box->Enabled = true;
   if (CListBox->Checked) CListBox->Enabled = true;
   if (CRingBox->Checked) CRingBox->Enabled = true;
   if (Attended) GetBtn->Enabled = true; //SetButtonState(true);
   TabSheet1->Enabled = true;
   TabSheet2->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocBegin(TObject *Sender)
{
   BytesReceived = 0;
   ProgressBar1->Position = 0;
   if (HttpCli1->RcvdStream) delete HttpCli1->RcvdStream;
   HttpCli1->RcvdStream = new TMemoryStream();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len)
{
   if (BytesTotal>0)
   {
      BytesReceived += Len;
      ProgressBar1->Position = (BytesReceived/BytesTotal)*100;
      Sleep(200);
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocEnd(TObject *Sender)
{
   ProgressBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1RequestDone(TObject *Sender,
	THttpRequest RqType, WORD Error)
{
   TStringList *tmp;
   AnsiString s,TxtFile;
   if (Error)
   {
      //GetBtn->Caption = "Done";
      PageControl1->ActivePage = TabSheet3;
      TStringList *tmp = new TStringList();
      tmp->Add("HTTP Error = "+AnsiString(Error));
      tmp->Add("HTTP Reason = "+HttpCli1->ReasonPhrase);
      TabSet->Tabs->AddObject("Error",tmp);
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      DocMemo->Lines->Text = tmp->Text;
//    while (TabSet->Tabs->Count)
//    {
//       DocMemo->Clear();
//       TStringList *tmp = (TStringList*)TabSet->Tabs->Objects[0];
//       TabSet->Tabs->Delete(0);
//       delete tmp;
//    }
      UrlsBtn->Enabled = true;
      return;
   }
   switch (RqType)
   {
      case httpHEAD:
      {
         //sm(HttpCli1->RcvdHeader->Text);
         for (int i=0; i<HttpCli1->RcvdHeader->Count; i++)
         {
            s = HttpCli1->RcvdHeader->Strings[i];
            if (s.Pos("Content-Length: ")==1)
               BytesTotal = s.SubString(17,16).ToIntDef(0);
         }
         HttpCli1->GetASync();
         break;
      }
      case httpGET:
      {
         tmp = new TStringList();
         HttpCli1->RcvdStream->Seek(0,soFromBeginning);
         tmp->LoadFromStream(HttpCli1->RcvdStream);
         int idx = TabSet->Tabs->IndexOf(CurDoc);
         if (idx>=0)
         {  // this is already downloaded & needs to be replaced
            TStringList *old = (TStringList*)TabSet->Tabs->Objects[idx];
            TabSet->Tabs->Objects[idx] = (TObject*)tmp;
            delete old;
         }
         else
         {  // new doc
            TabSet->Tabs->AddObject(CurDoc,tmp);
            idx = TabSet->Tabs->Count-1;
         }
         TabSet->TabIndex = idx;
         // handle html
         AnsiString doc = tmp->Text.UpperCase();
         if (doc.Pos("<HTML>") && doc.Pos("<PRE>") && doc.Pos("</PRE>"))
         {
            while (tmp->Count && tmp->Strings[0].UpperCase().Trim()!="<PRE>")
               tmp->Delete(0); if (tmp->Count) tmp->Delete(0);
            while (tmp->Count && tmp->Strings[tmp->Count-1].UpperCase().Trim()!="</PRE>")
               tmp->Delete(tmp->Count-1);
            if (tmp->Count) tmp->Delete(tmp->Count-1);
         }
         // end handle html
         DocMemo->Lines->Text = tmp->Text;
         DocMemo->SelStart = 0;
         CurBox->Enabled = false;
         Label1->Caption = "";
         Application->ProcessMessages();
         Sleep(100);
         // test validity of documents...
         GetBtn->Click();
         delete HttpCli1->RcvdStream;
         HttpCli1->RcvdStream = NULL;
         break;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall THttpForm::GetDefaultURL(AnsiString &path)
{
   AnsiString URL;
   TStringList *urls = new TStringList(); GetAppData(urls,path);
   if (urls->Count) URL = urls->Strings[0];
   delete urls;
   return URL;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetAppURLs()
{
   if ((MListURL = GetDefaultURL(StatsURLs+PS+MListTxt))=="") {
      MListBox->Checked=false; MListBox->Enabled=false;
   } else MListBox->Enabled=true;

   if ((MRingURL = GetDefaultURL(StatsURLs+PS+MRingTxt))=="") {
      MRingBox->Checked=false; MRingBox->Enabled=false;
   } else MRingBox->Enabled=true;

   if ((MTyp2URL = GetDefaultURL(StatsURLs+PS+MTyp2Txt))=="" || ErrorCheck->Checked) {
      MTyp2Box->Checked=false; MTyp2Box->Enabled=false;
   } else MTyp2Box->Enabled=true;

   if ((CListURL = GetDefaultURL(StatsURLs+PS+CListTxt))=="") {
      CListBox->Checked=false; CListBox->Enabled=false;
   } else CListBox->Enabled=true;

   if ((CRingURL = GetDefaultURL(StatsURLs+PS+CRingTxt))=="") {
      CRingBox->Checked=false; CRingBox->Enabled=false;
   } else CRingBox->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::CancelBtnClick(TObject *Sender)
{
   Timer1->Enabled = false; Label1->Caption = "";
   OkBtn->Enabled = true;
   Attended = true;
   if (!GetBtn->Enabled)
   {
      GetBtn->Enabled = true;
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      CancelAnyway = true;
      HttpCli1->Abort();
      Attended = true;
      return;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer1Timer(TObject *Sender)
{
   if (Label1->Caption=="") Label1->Caption = Cap; else Label1->Caption = "";
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ProxyPswdBoxClick(TObject *Sender)
{
   if (!ProxyPswdBox->Checked)
      ProxyPswdEdit->PasswordChar = '\0';
   else
      ProxyPswdEdit->PasswordChar = '*';
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::PageControl1Changing(TObject *Sender,
  bool &AllowChange)
{
   if (PageControl1->ActivePage==TabSheet3)
      ActiveControl = DocMemo;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::UrlsBtnClick(TObject *Sender)
{
   ManageURLs(this,ErrorCheck->Checked);
   GetAppURLs();
}
//---------------------------------------------------------------------------
#define TABSTRINGS(i) ((TStrings*)TabSet->Tabs->Objects[i])
void __fastcall THttpForm::TabSetChange(TObject *Sender, int NewTab,
   bool &AllowChange)
{
   bool locked=LockWindowUpdate(Handle);
   int idx = TabSet->TabIndex;
   if (idx>=0) TABSTRINGS(idx)->Text = DocMemo->Lines->Text;
   DocMemo->Lines->Text = TABSTRINGS(NewTab)->Text;
   DocMemo->SelStart = 0;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormResize(TObject *Sender)
{
   CancelBtn->Left = Width - 95;
   OkBtn->Left = Width - 179;
   GetBtn->Left = Width - 265;
   ProgressBar1->Width = Width - 297;
   Label1->Top = Height - 74;
   Label1->Width = Width - 42;//ProgressBar1->Left+(ProgressBar1->Width/2)-(Label1->Width/2);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ErrorCheckClick(TObject *Sender)
{
  if (ErrorCheck->Checked)
  {
     MTyp2Box->Checked = false; MTyp2Box->Enabled = false;
     CTyp1Box->Visible = true;
  }
  else
  {
     CTyp1Box->Visible = false;
     MTyp2Box->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::RemHlpBtnClick(TObject *Sender)
{
   OpenHelp("Remailer","Remailers & Remailer Documents","Introduction",Application->MainForm);
}
//---------------------------------------------------------------------------
/*char* __fastcall GenerateType1List()
{
   char* nokeyfound="----------";
   AnsiString tmps,shrt,addr,caps,line,keyid,type1str,
      ctyp1txt=MixDir()+CTyp1Txt,clisttxt=MixDir()+CListTxt,
      cringtxt=MixDir()+CRingTxt;

   int d,t,r,i,p;
   TStringList *activ = new TStringList();
   TStringList *rlist = new TStringList();
   TStringList *type1 = new TStringList();
   TStringList *disab = new TStringList();
   // get disabled keys from type1.list
   if (FileExists(ctyp1txt)) disab->LoadFromFile(ctyp1txt);
   d=0; while (d<disab->Count)
   {
      if (disab->Strings[d].SubString(1,1)!="#") disab->Delete(d);
      else d++;
   }
   // start with the remailer stats report
   if (FileExists(clisttxt)) rlist->LoadFromFile(clisttxt);
   for (r=0; r<rlist->Count; r++)
   {
      line = rlist->Strings[r].Trim();
      if (line.Pos("$remailer{")==1) // get remailer def lines
      {
         shrt = GetParam(1,line,"\"");
         caps = GetParam(3,line,"\"");
         if ((p=caps.Pos("<"))==1) caps.Delete(p,1);
         if ((p=caps.Pos(">"))>0 ) caps.Delete(p,1);
         //addr = GetParam(0,caps," ");
         type1->Add(shrt+" "+caps);
      }
      else
      if (CListLineOk(line)) // get list of active remailers
      {
         activ->Add(GetParam(0,line," "));
      }
   }
   // dump all remailer defs not active in stats portion of list
   t=0; while (t<type1->Count)
   {
      if (activ->IndexOf(GetParam(0,type1->Strings[t]," "))<0) type1->Delete(t);
      else t++;
   }
   // get corresponding key id
   TStringList *keyids = new TStringList();
   keyids->SetText(PgpGetUserIdsKeyIds(cringtxt.c_str()));
   for (t=0; t<type1->Count; t++)
   {
      keyid = nokeyfound;
      type1str = type1->Strings[t];
      shrt = GetParam(0,type1str," ");
      addr = GetParam(1,type1str," ");
      for (i=0; i<keyids->Count; i++)
      {
         line = keyids->Strings[i];
         if (line.Pos(addr)>0)
         {
            keyid = "0x"+line.SubString(1,8);
            break;
         }
      }
      type1str = "";
      p=2; while (!(caps=GetParam(p,type1->Strings[t]," ")).IsEmpty())
      {
         type1str += " "+caps;
         p++;
      }
      type1->Strings[t] = shrt+" "+addr+" "+keyid+type1str;
   }
   delete keyids;
   // delete disableds in type1.list and add the actual disabled line
   for (d=0; d<disab->Count; d++)
   {
      line = disab->Strings[d].SubString(2,512);
      while ((t=type1->IndexOf(line))>=0)
         type1->Delete(t);
      type1->Add("#"+line);
   }
   // look for keys that did not have a key available
   TStringList *nokeys = new TStringList();
   for (t=0; t<type1->Count; t++)
   {
      line = type1->Strings[t];
      if (line.Pos(nokeyfound)>0 && line[1]!='#')
         nokeys->Add(GetParam(0,line," ")+" "+GetParam(1,line," "));
   }
   // inform the user of problem remailers
   if (nokeys->Count)
   {
      MsgBox(
         s("=================SOME PGP KEYS NOT FOUND=================\n")+
         s("\nYou have ")+s(nokeys->Count)+s(" remailers in your type1.list file that you do not have PGP keys\n")+
         s("for. Please have a look. You've got 3 options.\n\n")+
         s("1) If you updated your pubring.asc from the same source as your current\n")+
         s("rlist.txt, you will more than likely get that key. 2) You can leave them 'as is'.\n")+
         s("They won't be used, until a key is found, but I'll nag you with this dialog,\n")+
         s("after updates. 3) You can disable them with a pound sign '#' in front of those\n")+
         s("remailers in the type1.list file. In that case, I won't nag you, but I won't add\n")+
         s("those new keys when I find them, either.\n \n \n")+
         nokeys->Text+s("\n \n \n"),
         "TYPE1.LIST",
         MB_OK
      );
   }
   delete nokeys;

   AnsiString type1lines = type1->Text;
   delete disab;
   delete type1;
   delete activ;
   return type1lines.c_str();
}
*/
//---------------------------------------------------------------------------
/*char* __fastcall GenerateType2List()
{
   char* nokeyfound="--------------------------------------------------------";
   AnsiString shrt,addr,mver,caps,tline,mline,nline,line,mshort,tshort,keyid,type2str,
      mlisttxt=MixDir()+MListTxt,mtyp2txt=MixDir()+MTyp2Txt,
      mringtxt=MixDir()+MRingTxt;

   int t,m,n;
   TStringList *mlist = new TStringList();
   TStringList *mring = new TStringList();
   TStringList *type2 = new TStringList();
   if (FileExists(mlisttxt)) mlist->LoadFromFile(mlisttxt);
   if (FileExists(mtyp2txt)) type2->LoadFromFile(mtyp2txt);
   if (FileExists(mringtxt)) mring->LoadFromFile(mringtxt);
   // remove all but disabled keys from type2.list
   t=0; while (t<type2->Count)
   {
      if (type2->Strings[t].SubString(1,1)!="#") type2->Delete(t);
      else t++;
   }
   // add keys from pubring.mix
   for (m=0; m<mring->Count; m++)
   {
      mline = mring->Strings[m]; if (MixRingLineOk(mline)) continue;
      if (type2->IndexOf(mline)<0 && type2->IndexOf("#"+mline)<0)
         type2->Add(mline);
   }

sm(type2->Text);
   // compare with mlist.txt
   TStringList *nokeys = new TStringList();
   for (m=0; m<mlist->Count; m++)
   {
      mline = mlist->Strings[m];
      if (MListLineOk(mline))
      {
         int idx=-1;
         mshort = GetParam(0,mline," ");
         for (t=0; t<type2->Count;t++)
         {
            tshort = GetParam(0,type2->Strings[t]," ").Trim();
            if (mshort==tshort || mshort=="#"+tshort)
            {
               idx = t;
               break;
            }
         }
         if (idx<0) nokeys->Add(GetParam(0,mline," ")+" "+nokeyfound);
      }
   }
   // inform the user of problem remailers
   if (nokeys->Count)
   {
      for (n=0; n<nokeys->Count; n++)
      {
         nline = nokeys->Strings[n]; type2->Add(nline);
         nokeys->Strings[n] = GetParam(0,nline," ");
      }
      MsgBox(
         s("=================SOME MIX KEYS NOT FOUND=================\n")+
         s("\nYou have ")+s(nokeys->Count)+s(" remailer(s) in your type2.list file that you do not have MIX key(s)\n")+
         s("for. Please have a look. You've got 3 options in dealing with this.\n\n")+
         s("1) If you update your pubring.mix from the same source as your current\n")+
         s("mlist.txt, you will more than likely get that key. 2) You can leave them 'as is'.\n")+
         s("They won't be used, until a key is found, but I'll nag you with this dialog,\n")+
         s("after updates. 3) You can disable them with a pound sign '#' in front of those\n")+
         s("remailers in the type2.list file. In that case, I won't nag you, but I won't add\n")+
         s("those new keys when I find them, either.\n \n \n")+
         nokeys->Text+s("\n \n \n"),
         "TYPE2.LIST",
         MB_OK
      );
   }
   delete nokeys;

   type2->Sorted = true;
   AnsiString type2lines = type2->Text;
   delete type2;
   return type2lines.c_str();
}*/
//---------------------------------------------------------------------------
/*bool __fastcall THttpForm::MTyp2Ok(TStrings *Doc)
{
   int cnt=0;
   for (int i=0; i<Doc->Count; i++)
      if (MixRingLineOk(Doc->Strings[i])) cnt++;
   if (cnt==0)
   {
      TabSet->TabIndex = Tabs->IndexOf(MTyp2Txt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'type2.list' document appears corrupt. I've scanned\n")+
         s("all "+s(Doc->Count)+" lines and found no mix key descriptions at all!\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MTyp2Txt.LowerCase(),
         MB_OK);
      return false;
   }
   if (cnt!=Doc->Count)
   {
      TabSet->TabIndex = Tabs->IndexOf(MTyp2Txt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'type2.list' document appears corrupt. I've scanned\n")+
         s("all "+s(Doc->Count)+" lines and found only "+s(cnt)+" mix key descriptions! Every\n")+
         s("line should be a valid description.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MTyp2Txt.LowerCase(),
         MB_OK);
      return false;
   }
   return true;
}
*/
/*
//---------------------------------------------------------------------------
void __fastcall THttpForm::SaveStatistics()
{
   TStrings *TxtList;
   AnsiString TxtFile,descrip,line;
   int i,bakcopies=STATSBAKCOPIES,idx=TabSet->TabIndex;
   // copy current to tab stringlist to get possible edits
   if (idx>=0) ((TStringList*)Tabs->Objects[idx])->Text = DocMemo->Lines->Text;
   // process tabs
   for (i=0; i<TabSet->Tabs->Count; i++)
   {
      if ((TxtFile=Tabs->Strings[i])=="Error") continue;
      TxtList = dynamic_cast<TStrings*>(Tabs->Objects[i]);
      if (!TxtList || TxtList && TxtList->Count && TxtList->Text.Pos(CorruptReport)==1)
         continue;
      if (ErrorCheck->Checked)
      {
        // THIS IS THE MRINGTXT DOCUMENT
         if (TxtFile==MRingTxt)
         {
            TStringList *type2 = new TStringList(); //type2->Sorted = true;
            type2->SetText(MixAddNewRemailerKeys(TxtList->Text.c_str()));
            if (type2->Count && FileExists(MRingTmp))
            {
               TxtList->LoadFromFile(MRingTmp);
               DeleteFile(MRingTmp.c_str());
            }
            // save new type2
            SaveToFileBak(type2,MixDir()+MTyp2Txt,bakcopies);
            delete type2;
         }
         // THIS IS THE CRINGTXT DOCUMENT
         if (TxtFile==CRingTxt && HasPgp())
         {
            TStringList *type1 = new TStringList(); type1->Sorted = true;
            // add keys, leaving new ring in cringtmp return type1
            type1->SetText(PgpAddNewRemailerKeys(TxtList->Text.c_str()));
            if (type1->Count && FileExists(CRingTmp))
            {
               // get the keys from text file
               TxtList->LoadFromFile(CRingTmp);
               DeleteFile(CRingTmp.c_str());
            }
            // save new type1
            SaveToFileBak(type1,MixDir()+CTyp1Txt,bakcopies);
            delete type1;
         }
      }
      SaveToFileBak(TxtList,MixDir()+TxtFile,bakcopies);
   }
}
*/
//---------------------------------------------------------------------------

