//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MBoxWin.h"
#include "FileMan.h"
#include "Global.h"
#include "MsgWin.h"
#include "MsgInWin.h"
#include "PicBoxDlg.h"
#include "NNameDlg.h"
#include "HeadMan.h"
#include "pop3mail.h"
//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma resource "*.dfm"
TMailboxWin *MailboxWin;
//---------------------------------------------------------------------------
TMailboxWin* __fastcall FindOpenMailbox(AnsiString &BoxName)
{
   TMailboxWin *mw=NULL;
   TForm *mf=Application->MainForm;
   for (int i=0; i<mf->MDIChildCount; i++)
      if ((mw=dynamic_cast<TMailboxWin*>(mf->MDIChildren[i]))!=NULL)
      {
         if (mw->BoxName()==BoxName) break;
         mw = NULL;
      }
   return mw;
}
//---------------------------------------------------------------------------
TMailboxWin* __fastcall OpenMailbox(AnsiString &BoxName)
{
   if (BoxName.IsEmpty()) return NULL;
   if ((MailboxWin=FindOpenMailbox(BoxName))==NULL)
      MailboxWin = new TMailboxWin(Application->MainForm,BoxName);
   else
      MailboxWin->BringToFront();
   return MailboxWin;
}
//---------------------------------------------------------------------------
bool __fastcall MailboxExists(AnsiString &BoxName)
{
   bool exists=false;
   TStringList *boxes = new TStringList();
   GetAppData(boxes,UserMailboxes);
   for (int i=0; i<boxes->Count; i++)
      if (boxes->Strings[i]==BoxName)
      {
         exists = true;
         break;
      }
   delete boxes;
   return exists;
}
//---------------------------------------------------------------------------
void __fastcall DelMailbox(AnsiString &BoxName)
{
   // remove all messages
   TStringList *mail = new TStringList();
   DelMessages(BoxName,NULL);
   // remove empty mailbox
   PutAppData(UserMailboxes+PS+BoxName,NULL);
   DelMailboxPos(BoxName);
   DelMenubox(BoxName);
   delete mail;
}
//---------------------------------------------------------------------------
long __fastcall DelMessages(AnsiString &Boxname, bool *Selected)
{
   if (!FileExists(AppDat)) return 0;

   AnsiString key;
   long deletes=0;
   TFMindex *master,*mailboxes,*mailbox;
   TFileManager *fman = new TFileManager(AppDat);
   master = new TFMindex(fman);
   mailboxes = new TFMindex(fman,(AnsiString)UserMailboxes,master);
   mailbox = new TFMindex(fman,Boxname,mailboxes);
   for (int i=mailbox->Count; i>0; i--)
   {
      if (!Selected || Selected[i])
      {
         key = mailbox->Strings[i-1];
         TFLoffset ofs = mailbox->GetOffset(key);
         if (ofs != FLNIL) mailbox->fm->Deallocate(ofs);
         mailbox->Delete(i-1);
         deletes++;
      }
   }
   mailbox->Save();
   delete mailbox;
   delete mailboxes;
   delete master;
   delete fman;

   return deletes;
}
//---------------------------------------------------------------------------
long __fastcall TransferMessages(AnsiString &Boxname, bool *Selected,
   AnsiString &NewBoxname)
{
   if (!FileExists(AppDat)) return 0;

   AnsiString key;
   long transfers=0;
   TFMindex *master,*mailboxes,*mailbox,*newbox;
   TFileManager *fman = new TFileManager(AppDat);
   master = new TFMindex(fman);
   mailboxes = new TFMindex(fman,(AnsiString)UserMailboxes,master);
   mailbox = new TFMindex(fman,Boxname,mailboxes);
   newbox = new TFMindex(fman,NewBoxname,mailboxes);
   for (int i=mailbox->Count; i>0; i--)
   {
      if (!Selected || Selected[i])
      {
         key = mailbox->Strings[i-1];
         TFLoffset ofs = mailbox->GetOffset(key);
         newbox->AddObject(key,(TObject*)ofs);
         mailbox->Delete(i-1);
         transfers++;
      }
   }
   newbox->Save();
   mailbox->Save();
   delete newbox;
   delete mailbox;
   delete mailboxes;
   delete master;
   delete fman;

   return transfers;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CreateMailbox(AnsiString &BoxName)
{
   AnsiString boxname = BoxName;
   if ( boxname.IsEmpty()) boxname = GetNewMailboxName();
   if (!boxname.IsEmpty())
   {
      TStringList *emptybox = new TStringList();
      PutAppData(UserMailboxes+PS+boxname,emptybox);
      delete emptybox;
      SetMailboxPos(boxname,0);
      AddMenubox(boxname);
   }
   return boxname;
}
//---------------------------------------------------------------------------
void __fastcall SetMailboxPos(AnsiString &BoxName, long position)
{
   TStringList *poses = new TStringList();
   GetAppData(poses,MailboxPos);
   poses->Values[BoxName] = AnsiString((int)position);
}
//---------------------------------------------------------------------------
void __fastcall DelMailboxPos(AnsiString &BoxName) // deletes mailbox saved position
{
   TStringList *poses = new TStringList();
   GetAppData(poses,MailboxPos);
// this section doesn't actually work.. the pos is re-entered when mailbox closes
// the later section _does_ tidy up any orphans from earlier deletes
/* for (int i=0; i<poses->Count; i++)
      if (poses->Strings[i]==BoxName)
      {
         poses->Delete(i);
         break;
      }
*/
   // cleanup any lingering positions (from deleted boxes)
   TStringList *allboxes = new TStringList();
   GetAppData(allboxes,UserMailboxes);
   int pos=0; while (pos<poses->Count) // iterate through position entries
   {
      bool ok=false;
      for (int all=0; all<allboxes->Count; all++) // iterate through all mailboxes
         // does position entry have a corresponding mailbox?
         if (poses->Names[pos]==allboxes->Strings[all]) // do any box names = the pos name
         {
            ok = true;
            break;
         }
      if (!ok) poses->Delete(pos);
      else pos++;
   }
   PutAppData(MailboxPos,poses);
   delete allboxes;
   delete poses;
}
//---------------------------------------------------------------------------
bool __fastcall IsMenubox(AnsiString &BoxName)
{
   TStringList *boxes = new TStringList();
   GetAppData(boxes,MailboxBoxmenu);
   bool ok = boxes->IndexOf(BoxName)>=0;
   delete boxes;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall DelMenubox(AnsiString &BoxName)
{
   int pos;
   bool didit = false;
   TStrings *menu = new TStringList();
   GetAppData(menu,MailboxBoxmenu);
   if ((pos=menu->IndexOf(BoxName))>=0)
   {
      menu->Delete(pos);
      PutAppData(MailboxBoxmenu,menu);
      didit = true;
      Application->MainForm->Perform(WM_LOADBOXMENU,0,NULL);
   }
   delete menu;
   return didit;
}
//---------------------------------------------------------------------------
void __fastcall AddMenubox(AnsiString &BoxName)
{
   TStrings *menu = new TStringList();
   GetAppData(menu,MailboxBoxmenu);
   if (menu->IndexOf(BoxName)<0)
   {
      menu->Add(BoxName);
      PutAppData(MailboxBoxmenu,menu);
   }
   Application->MainForm->Perform(WM_LOADBOXMENU,0,NULL);
   delete menu;
}
//---------------------------------------------------------------------------
// TMailGrid == Mailbox Index Window
//---------------------------------------------------------------------------
__fastcall TMailGrid::TMailGrid(TComponent *Owner)
   : TDrawGrid(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMailGrid::TMailGrid(TComponent *Owner, AnsiString &BoxName)
   : TDrawGrid(Owner)
{
   Mailbox = BoxName; Parent = dynamic_cast<TWinControl*>(Owner);
   Align = alClient;
   DefaultDrawing = false;
   DefaultRowHeight = 18;
   FixedRows = 1;
   Options << goRowSelect << goThumbTracking;
   Options >> goRangeSelect;
   ScrollBars = ssBoth;
   RowHeights[0] = 22;
   ColCount = HasPop3() ? 4 : 3;
   FixedCols = 0;
   ImageList = NULL;
   if (HasPop3())
   {
      ColWidths[0] = 20;
      ColWidths[1] = 108;//117;
      ColWidths[2] = 180;
      ColWidths[3] = Width;
   }
   else
   {
      ColWidths[0] = 108;
      ColWidths[1] = 180;
      ColWidths[2] = Width;
   }
// OnTopLeftChanged = TopLeftChanged;
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::SelectAll()
{
   for (int i=1; i<RowCount; i++) Selected[i] = true;
   for (int i=TopRow; i<=TopRow+VisibleRowCount; i++)
      InvalidateRow(i);
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::DrawCell(long ACol, long ARow, const Windows::TRect &Rect,
   TGridDrawState State)
{
   if (ARow<0 || ARow>RowCount-1) return;

   TColor prev;
   RECT r; SetRect(&r,Rect.Left,Rect.Top,Rect.Right,Rect.Bottom);
   AnsiString text,str=MailList->Strings[ARow];
   AnsiString DataKey = UserMailboxes+PS+Mailbox+PS+str;
   if (HasPop3())
   {
      switch (ACol)
      {
         case 0: text = GetMsgStatus(DataKey); break;
         case 1: text = MessageDate(str); break;
         case 2: text = MessageWho(str); break;
         case 3: text = MessageSubject(str); break;
      }
   }
   else
   {
      switch (ACol)
      {
         case 0: text = MessageDate(str); break;
         case 1: text = MessageWho(str); break;
         case 2: text = MessageSubject(str); break;
      }
   }
   Canvas->Font->Color = clWindowText;
   if (ARow==0)
   {
      RECT h; SetRect(&h,Rect.Left,Rect.Top,Rect.Right,Rect.Bottom);
      TPoint pts[6] = {
         {h.left,h.bottom-1},{h.left,h.top},{h.right,h.top},
         {h.right-1,h.top+1},{h.right-1,h.bottom-1},{h.left,h.bottom-1}
      };
      Canvas->Pen->Color = clBtnHighlight;
      Canvas->Polyline(&pts[0],2);
      Canvas->Pen->Color = clBtnShadow;
      Canvas->Polyline(&pts[3],2);
      Canvas->Brush->Color = clBtnFace;
      InflateRect(&h,-1,-1);
      Canvas->FillRect(TRect(h));
      r.top++;
   }
   else
   if (Selected[ARow])
   {
      Canvas->Font->Color = clHighlightText;
      Canvas->Brush->Color = clHighlight;
      Canvas->FillRect(TRect(r));
   }
   else
   {
      Canvas->Font->Color = clWindowText;
      Canvas->Brush->Color = clWindow;
      Canvas->FillRect(TRect(r));
   }

   InflateRect(&r,-1,-2); r.right-=3;
/* if (HasPop3() && ACol==0 && ARow>0 && ImageList)
   {
      switch  (text[1])//&& IsIncoming(DataKey) && text=="N")
      {
         case 'N':
            prev = Canvas->Brush->Color;
            Canvas->Brush->Color = clRed;
            Canvas->Ellipse(r.left+5,r.top+3,r.left+13,r.top+11);
            Canvas->Brush->Color = prev;
            break;
         case 'S':
            if (ImageList) ImageList->Draw(Canvas,r.left+2,r.top+2,2);
            break;
         case 'R':
            if (ImageList) ImageList->Draw(Canvas,r.left+2,r.top+2,2);
            break;
      }
   }
   else
*/
   if (HasPop3() && ACol==0 && ARow>0 && text=="N")
   {
      prev = Canvas->Brush->Color;
      Canvas->Brush->Color = clRed;
      Canvas->Ellipse(r.left+5,r.top+3,r.left+13,r.top+11);
      Canvas->Brush->Color = prev;
   }
   else
   {
      Canvas->TextRect(
         TRect(r),
         r.left+5,
         r.top,
         text
       );
   }

   if (ARow==Row && ARow!=0)
   {
      TRect fr=Rect; fr.Right++;
      Canvas->DrawFocusRect(fr);
   }
}
//---------------------------------------------------------------------------
__fastcall TMailGrid::~TMailGrid()
{
   CloseIndex();
}
//---------------------------------------------------------------------------
#define IDXSTRING(p,l) IndexStr.SubString(p,l)
AnsiString __fastcall TMailGrid::MessageDate(AnsiString &IndexStr)
{
   if (IndexStr==HeaderText) return GetParam(0,IndexStr," ");
   if (IndexStr.IsEmpty()) return "";

   AnsiString h,ampm="am";
   int H = IDXSTRING(12,2).ToIntDef(0);
   if (H>12) { H -= 12; ampm = "pm"; }
   h = H; if (h.Length()<2) h = "0"+h;
   return IDXSTRING(3,8)+"  "+h+":"+IDXSTRING(15,2)+" "+ampm+"  "+IndexStr.SubString(21,2);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailGrid::MessageWho(AnsiString &IndexStr)
{
   if (IndexStr==HeaderText) return GetParam(1,IndexStr," "); // header
   if (IndexStr.IsEmpty()) return "";

   AnsiString who,ic=InCode,oc=OutCode;
   if (IndexStr[23]==ic[1] || IndexStr[23]==oc[1])
      who=HeadMan->GetAddress(GetParam(1,IndexStr,FieldSep.c_str()));
   else
      who=GetParam(3,IndexStr," "); // original style index

   return who;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailGrid::MessageSubject(AnsiString &IndexStr)
{
   if (IndexStr==HeaderText) return GetParam(2,IndexStr," "); // header
   if (IndexStr.IsEmpty()) return "";

   int len,pos,fld;
   AnsiString sub,ic=InCode,oc=OutCode;
   if (IndexStr[23]==ic[1] || IndexStr[23]==oc[1]) // new style
      sub=GetParam(2,IndexStr,FieldSep.c_str());
   else
   {
      // original style
      len=IndexStr.Length();
      pos=len+1;
      fld=-2;
      for (int i=0; i<len; i++)
      {
         if (IndexStr[i]==' ') fld++;
         if (fld==(hPopLib?3:2))
         {
            pos = i+1;
            break;
         }
      }
      sub=IndexStr.SubString(pos,256);
   }
   return sub;
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::OpenIndex()
{
   MailList = new TStringList();
   GetAppData(MailList,UserMailboxes+PS+BoxName());
   if (MailList->Count)
      MailList->Insert(0,HeaderText);
   else
      MailList->Append(HeaderText);

   RowCount = MailList->Count;
   Selected = new bool[RowCount];
   ClearSelected();

   long top=TopRow, row=GridRow(GetBoxPos());
   if (row!=0 && top!=0)
   {
      top = RowCount<=VisibleRowCount ? 1 : row-VisibleRowCount/2;
    //if (RowCount-top<VisibleRowCount) top = RowCount-VisibleRowCount;
      if (top<1) top = 1;
   }
   Selected[row] = true;
   Anchor = row;
   TopRow = top;
   Row = row;
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::CloseIndex()
{
   SetBoxPos(Row);
   delete [] Selected;
   delete MailList;
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::RefreshIndex()
{

   long toprow = TopRow;
   CloseIndex(); OpenIndex();
   if (toprow>=0 && toprow<RowCount) TopRow = toprow;
   if (RowCount && RowCount<=VisibleRowCount) TopRow = 0;
   for (int i=TopRow; i<=TopRow+VisibleRowCount; i++)
      InvalidateRow(i);
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::SetBoxPos(int pos)
{
   TStringList *poses = new TStringList();
   GetAppData(poses,MailboxPos);
   poses->Values[BoxName()] = AnsiString(pos);
   PutAppData(MailboxPos,poses);
   delete poses;
}
//---------------------------------------------------------------------------
int __fastcall TMailGrid::GetBoxPos()
{
   TStringList *poses = new TStringList();
   GetAppData(poses,MailboxPos);
   int pos = poses->Values[BoxName()].ToIntDef(-1);
   delete poses;
   return pos;
}
//---------------------------------------------------------------------------
long __fastcall TMailGrid::SelCount()
{
   long sels=0;
   for (long i=1;i<RowCount; i++)
      if (Selected[i]) sels++;
   return sels;
}
//---------------------------------------------------------------------------
long __fastcall TMailGrid::TransferSelected(AnsiString &NewBoxname)
{
   TMailboxWin *mw;
   bool locked=LockWindowUpdate((TForm*)Parent->Handle);
   long count=TransferMessages(Mailbox,Selected,NewBoxname);
   RefreshIndex();
   if ((mw=FindOpenMailbox(NewBoxname))!=NULL)
      mw->MailGrid->RefreshIndex();
   if (locked) LockWindowUpdate(0);
   return count;
}
//---------------------------------------------------------------------------
long __fastcall TMailGrid::DeleteSelected()
{
   bool locked=LockWindowUpdate((TForm*)Parent->Handle);
   long count=DelMessages(Mailbox,Selected);
   RefreshIndex();
   if (locked) LockWindowUpdate(0);
   return count;
}
//---------------------------------------------------------------------------
long __fastcall TMailGrid::ClearSelected()
{
   long sels=0;
   for (long i=1; i<RowCount; i++)
      if (Selected[i])
      {
          Selected[i] = false;
          sels++;
      }
   return sels;
}
//---------------------------------------------------------------------------
long __fastcall TMailGrid::OpenSelected()
{
   long sels=0;
   for (long i=1; i<RowCount; i++)
      if (Selected[i])
      {
         if (IsIncoming(UserMailboxes+PS+Mailbox+PS+MailList->Strings[i]))
            OpenMessageIn(Mailbox,MailList->Strings[i]);
         else
            OpenMessage(Mailbox,MailList->Strings[i]);
         sels++;
      }
   return sels;
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::MouseDown(Controls::TMouseButton Button,
   Classes::TShiftState Shift, int X, int Y)
{
   if (Button==mbRight || Button==mbMiddle) return;
   if (Button==mbLeft && Shift.Contains(ssDouble) && !Shift.Contains(ssCtrl))
   {
      DblClick();
      return;
   }

   long col,row;
   MouseToCell(X,Y,col,row);
   if (row<1 || Row>RowCount-1) return;

   Row = row;
   if (Shift.Contains(ssShift))
   {
      SetSelected(Anchor,Row);
   }
   else
   if (Shift.Contains(ssCtrl))
   {
      Selected[Row] = !Selected[Row];
      InvalidateRow(Row);
      Anchor = Row;
   }
   else
   {
      SetSelected(Row);
      Anchor = Row;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::DblClick()
{
   OpenSelected();
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::KeyDown(unsigned short &Key, TShiftState Shift)
{
   if (Key==VK_SHIFT || Key==VK_CONTROL)// || Key==VK_MENU)
      return;
   if (Key==VK_SPACE)
   {
      Selected[Row] = !Selected[Row];
      Anchor = Row;
      InvalidateRow(Row);
      return;
   }
   if (Key==VK_RETURN)
   {
      DblClick();
      return;
   }

   long newrow=Row;
   switch (Key)
   {
      case VK_DOWN:
      case VK_RIGHT:
         newrow = GridRow(Row+1);
         break;
      case VK_UP:
      case VK_LEFT:
         newrow = GridRow(Row-1);
         break;
      case VK_NEXT:
         newrow = GridRow(Row+VisibleRowCount-1);
         break;
      case VK_PRIOR:
         newrow = GridRow(Row-VisibleRowCount-1);
         break;
      case VK_HOME:
         newrow = 1;
         break;
      case VK_END:
         newrow = RowCount-1;
         break;
   }
   if (newrow!=Row)
   {
      if (Shift.Contains(ssShift))
         SetSelected(Anchor,newrow);
      else
      {
         SetSelected(newrow);
         Anchor = newrow;
         Row = newrow;
      }
      Row = newrow;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMailGrid::SetSelected(long Anchor, long ToRow)
{
   bool sel,val;
   if (ToRow==-1)
   {
      for (long i=0; i<RowCount; i++)
      {
         sel = i==Anchor; val = Selected[i] != sel;
         Selected[i] = sel;
         if (val) InvalidateRow(i);
      }
   }
   else
   if (Anchor<ToRow)
   {
      for (long i=0; i<RowCount; i++)
      {
         sel = i>=Anchor && i<=ToRow; val = Selected[i]!=sel;
         if (i!=Anchor) Selected[i] = sel;
         if (val) InvalidateRow(i);
      }
   }
   else
   {
      for (long i=0; i<RowCount; i++)
      {
         sel = i>=ToRow && i<=Anchor; val = Selected[i] != sel;
         if (i!=Anchor) Selected[i] = sel;
         if (val) InvalidateRow(i);
      }
   }
}
//---------------------------------------------------------------------------
long __fastcall TMailGrid::GridRow(long row)
{
   if (row>RowCount-1) row = RowCount-1;
   if (row<0) row = 0;
   if (row==0 && RowCount>1) row=1;
   return row;
}
//---------------------------------------------------------------------------
/*void __fastcall TMailGrid::SetSelected(long Anchor, long ToRow)
{
   if (ToRow==-1)
   {
      for (long i=0; i<RowCount; i++)
      {
         bool sel=i==Anchor;
         bool val=Selected[i]!=sel;
         Selected[i] = i==Anchor;
         if (val) InvalidateRow(i);
      }
   }
   else
   if (Anchor<ToRow)
   {
      for (long i=0; i<RowCount; i++)
         if (i!=Anchor) Selected[i] = i>=Anchor && i<=ToRow;
   }
   else
   {
      for (long i=0; i<RowCount; i++)
         if (i!=Anchor) Selected[i] = i>=ToRow && i<=Anchor;
   }
}
*/
//---------------------------------------------------------------------------
// TMailboxWin == Mailbox Index Window
//---------------------------------------------------------------------------
__fastcall TMailboxWin::TMailboxWin(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMailboxWin::TMailboxWin(TComponent* Owner, AnsiString &MailBox)
   : TForm(Owner)
{
   Caption = MailBox;
   PopupMailboxMenuItem->Checked = IsMenubox(MailBox);
   MailGrid = new TMailGrid(this,MailBox);
   MailGrid->PopupMenu = PopupMenu;
   MailGrid->ImageList = ImageList1;
   MailGrid->OpenIndex();
   if (MailBox=="outbox")
   {
      PopupMailboxMenuItem->Checked = true;
      PopupMailboxMenuItem->Enabled = false;
   }
   FormResize(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   delete MailGrid;                    // because of 'can't create file' error
}
//---------------------------------------------------------------------------
__fastcall TMailboxWin::~TMailboxWin()
{
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::RefreshIndex()
{
   MailGrid->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::PopupMenuPopup(TObject *Sender)
{
   long count=MailGrid->SelCount();
   PopupTransferItem->Enabled = count>0;
   PopupDeleteItem->Enabled = count>0;
   PopupOpenItem->Enabled = count>0;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::PopupMailboxMenuItemClick(TObject *Sender)
{
   TMenuItem *item = PopupMailboxMenuItem;
   item->Checked = !item->Checked;
   if (item->Checked) AddMenubox(Caption); else DelMenubox(Caption);
}
//-------------------------------------------------------------------------
void __fastcall TMailboxWin::PopupRefreshItemClick(TObject *Sender)
{
   MailGrid->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::FormResize(TObject *Sender)
{
   MailGrid->ColWidths[hPopLib?3:2] = MailGrid->ClientWidth-1;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::PopupOpenItemClick(TObject *Sender)
{
   MailGrid->Cursor = crHourGlass;
   MailGrid->OpenSelected();
   MailGrid->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::PopupDeleteItemClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Delete selected message(s)!\n\nAre you sure?",
       "Delete Message",MB_OKCANCEL)==IDOK)
   {
      MailGrid->Cursor = crHourGlass;
      if (MailGrid->DeleteSelected()>0)
         MailGrid->RefreshIndex();
      MailGrid->Cursor = crDefault;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::PopupTransferItemClick(TObject *Sender)
{
   TMailboxWin *mw;
   AnsiString newbox;
   if ((newbox=GetTransferBoxname(BoxName()))!="")
   {
      MailGrid->Cursor = crHourGlass;
      Application->ProcessMessages();
      if (MailGrid->TransferSelected(newbox)>0)
      {
         MailGrid->RefreshIndex();
         if ((mw=FindOpenMailbox(newbox))!=NULL)
            mw->MailGrid->RefreshIndex();
      }
      MailGrid->Cursor = crDefault;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::PopupDeleteMailboxItemClick(TObject *Sender)
{
   AnsiString boxname = Caption;
   if (MsgBoxHwnd(Handle,"Delete mailbox '"+boxname+"' and contents!\n\nAre you sure?",
          "Delete Mailbox",MB_OKCANCEL)==IDOK &&
       MsgBoxHwnd(Handle,"Mail in '"+boxname+"' will be lost forever!",
          "Delete Mailbox",MB_OKCANCEL)==IDOK)
   {

      Cursor = crHourGlass;
      DelMailboxPos(boxname);
      DelMailbox(boxname);
      DelMenubox(boxname);
      Close();
   }
}
//---------------------------------------------------------------------------
long __fastcall TMailboxWin::GoNewMessages()
{
   if (MailGrid->RowCount==0) return -1;

   AnsiString MasterKey = UserMailboxes+PS+MailGrid->Mailbox;
   long row = MailGrid->RowCount-1; MailGrid->Row = row;
   while (row>1 && GetMsgStatus(MasterKey+PS+MailGrid->MailList->Strings[row-1])=='N')
      row--;
   MailGrid->Row = row;
   MailGrid->Selected[row] = true;
   return row;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::EditSelectAllItemClick(TObject *Sender)
{
   MailGrid->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TMailboxWin::PopSelectAllItemClick(TObject *Sender)
{
   MailGrid->SelectAll();
}
//---------------------------------------------------------------------------
/*
void __fastcall TMailGrid::TopLeftChanged(TObject *Sender)
{
   if (LeftCol==LastLeftCol) return;
   bool locked = LockWindowUpdate(AppMainForm->Handle);

   int i,w=0,lastcol=hPopLib?3:2;
   for (i=LeftCol; i<lastcol; i++) w += ColWidths[i];
   ColWidths[lastcol] = ClientWidth-(w+(i-1));

   if (LeftCol==lastcol) ColWidths[lastcol+1] = 0;
   else ColWidths[lastcol+1]=1000;
   AppProcessMessages();
   if (locked) LockWindowUpdate(0);
//   sm((int)LeftCol);
   LastLeftCol = LeftCol;
}*/
//---------------------------------------------------------------------------
