//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PreferDlg.h"
#include "global.h"
#include "fileman.h"
#include "mixmaster.h"
#include "pgpmail.h"
#include "pgpfiles.h"
#include "helpdlg.h"
#include "ImportDlg.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPreferForm *PreferForm;
//---------------------------------------------------------------------------
bool __fastcall GetPreferences(AnsiString &PageCap)
{
   bool ok=false;
   TColor mfcolor = AppMainForm->Color;
   PreferForm = new TPreferForm(AppMainForm);
   // hide pgp if no pgp dll
   PreferForm->PgpSheet->TabVisible = HasPgp();
   TPageControl *pc = PreferForm->PageControl1;
   int page = 0;
   for (int i=0; i<pc->PageCount; i++)
   {
      AnsiString cap = pc->Pages[i]->Caption.Trim().LowerCase();
      if (pc->Pages[i]->Caption.Trim().LowerCase()==PageCap.LowerCase() && pc->Pages[i]->TabVisible)
      {
         page = i;
         break;
      }
   }
   pc->ActivePage = pc->Pages[page];
   CenterDialog(PreferForm,AppMainForm);
   PreferForm->ShowModal();
   if (PreferForm->ModalResult==mrOk) ok=true;
   else
   {
      if (AppMainForm->Color != mfcolor)
      {
          AppMainForm->Color = mfcolor;
        ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
/*bool __fastcall GetPreferences()
{
   bool ok=false;
   TColor mfcolor = AppMainForm->Color;
   PreferForm = new TPreferForm(AppMainForm);
   PreferForm->PgpSheet->TabVisible = HasPgp();
   CenterDialog(PreferForm,AppMainForm);
   PreferForm->ShowModal();
   if (PreferForm->ModalResult==mrOk) ok=true;
   else
   {
      if (AppMainForm->Color != mfcolor)
      {
          AppMainForm->Color = mfcolor;
        ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
      }
   }
   return ok;
}*/
//---------------------------------------------------------------------------
__fastcall TPreferForm::TPreferForm(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString txt;
   ini = new TStringList();
   GetAppData(ini,AppIniValues);
//sm(ini->Text);
   // general
   txt = ini->Values[QuoteMarks];
   if (txt.IsEmpty()) txt = "> "; txt = "\""+txt+"\"";
   QuoteMarkEdit->Text = txt;
   ColorBox->Color = AppMainForm->Color;
   GetAppData(ColorDialog1->CustomColors,"CustomColors");
   StatsMinutes->Text = ini->Values[StatsMinUpdates];
   // editor
   EdWrapWinBtn->Checked = ini->Values[WordWrap].ToIntDef(1);
   EdWrapNotBtn->Checked = !EdWrapWinBtn->Checked;
   EdWrapShowBox->Checked = ini->Values[WordWrapShowBox].ToIntDef(0);
   // sending mail
   bool checked = ini->Values[SendWrapChars].ToIntDef(0);
   SendWrapCharEdit->Color = checked ? clWindow:clBtnFace;
   SendWrapCharBtn->Checked = checked;
   if (!SendWrapCharBtn->Checked) SendWrapCharEdit->Enabled = false;
   txt = ini->Values[SendWrapCharsCount];
   SendWrapCharEdit->Text = txt.IsEmpty()?AnsiString("65"):txt;
   SendWrapWinBtn->Checked = ini->Values[SendWrapWin].ToIntDef(1);
   SendWrapNotBtn->Checked = ini->Values[SendWrapNot].ToIntDef(0);
   DontWrapQuotes->Checked = ini->Values[DontWrapQuoted].ToIntDef(0);

   // pgp
   AnsiString pub,sec,imp;
   // keyrings
   pub = ini->Values[PgpPubRing];
   if (pub.IsEmpty() || !FileExists(pub)) pub = PgpPublicRing();
   PgpPublicKeyring->Text = pub;
   sec = ini->Values[PgpSecRing];
   if (sec.IsEmpty() || !FileExists(sec)) sec = PgpSecretRing();
   PgpSecretKeyring->Text = sec;
   imp = ini->Values[PgpImpRing];
   PgpImportKeyring->Text = imp.IsEmpty() ? PgpImportFile : imp;
   if (!FileExists(imp)) ImportBtn->Enabled = false;
   // init
   PageControl1->ActivePage = TabSheet3;

   // init OpenPubring dialog
   OpenPubring->InitialDir = AppDir;
   OpenPubring->FileName = "pubring.pkr";
   AnsiString curpubring = PgpPublicRing();
   if (FileExists(curpubring))
   {
      OpenPubring->InitialDir = ExtractFilePath(curpubring);
      OpenPubring->FileName = ExtractFileName(curpubring);
   }
   OpenPubring->Filter = "Public Keyring Files (*.pkr;*.pubkr;*.pgp)|*.PKR; *.PUBKR; *.PGP|All Files (*.*)|*.*";
   // init OpenSecring dialog
   OpenSecring->InitialDir = AppDir;
   OpenSecring->FileName = "secring.pkr";
   AnsiString cursecring = PgpSecretRing();
   if (FileExists(cursecring))
   {
      OpenSecring->InitialDir = ExtractFilePath(cursecring);
      OpenSecring->FileName = ExtractFileName(cursecring);
   }
   OpenSecring->Filter = "Secret Keyring Files (*.skr;*.prvkr;*.pgp)|*.SKR; *.PVRKR; *.PGP|All Files (*.*)|*.*";
   // init OpenSecring dialog
   OpenImport->InitialDir = AppDir;
   OpenImport->FileName = PgpImportFile;
   AnsiString curimpring=GetAppIni(PgpImpRing,PgpImportFile);
   if (FileExists(curimpring))
   {
      OpenImport->InitialDir = ExtractFilePath(curimpring);
      OpenImport->FileName = ExtractFileName(curimpring);
   }
   OpenImport->Filter = "Import Keyring Files (*.asc)|*.ASC|All Files (*.*)|*.*";
   // help available
   PgpHelpBtn->Visible = FileExists(QSHelp());
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      Hide();
      // general
      AnsiString qm=QuoteMarkEdit->Text;
      if (qm[1]=='\"') qm = qm.SubString(2,16);
      if (qm[qm.Length()]=='\"') qm.SetLength(qm.Length()-1);
      ini->Values[QuoteMarks] = qm;
      ini->Values[StatsMinUpdates] = StatsMinutes->Text;
      ini->Values[WorkSpaceColor] = AnsiString(ColorBox->Color);
      //if (AppMainForm->Color != ColorBox->Color)
          AppMainForm->Color  = ColorBox->Color;
      TStrings *colors = ColorDialog1->CustomColors;
      int p; while ((p=colors->IndexOf("FFFFFFFF"))>=0) colors->Delete(p);
      PutAppData("CustomColors",ColorDialog1->CustomColors);
      // editor
      ini->Values[WordWrap] = EdWrapWinBtn->Checked?"1":"0";
      ini->Values[WordWrapShowBox] = EdWrapShowBox->Checked?"1":"0";
      // sending mail
      ini->Values[SendWrapChars] = SendWrapCharBtn->Checked?"1":"0";
      int count = SendWrapCharEdit->Text.ToIntDef(0);
      ini->Values[SendWrapCharsCount] = AnsiString(count<16?16:count);
      ini->Values[SendWrapWin] = SendWrapWinBtn->Checked?"1":"0";
      ini->Values[SendWrapNot] = SendWrapNotBtn->Checked?"1":"0";
      ini->Values[DontWrapQuoted] = DontWrapQuotes->Checked?"1":"0";
      // pgp
      ini->Values[PgpPubRing] = PgpPublicKeyring->Text;
      ini->Values[PgpSecRing] = PgpSecretKeyring->Text;
      ini->Values[PgpImpRing] = PgpImportKeyring->Text;
      // store data
      PutAppData(AppIniValues,ini);
   }
}
/*
void __fastcall TPreferForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      // general
      AnsiString qm=QuoteMarkEdit->Text;
      if (qm[1]=='\"') qm = qm.SubString(2,16);
      if (qm[qm.Length()]=='\"') qm.SetLength(qm.Length()-1);
      PutAppIni(QuoteMarks,qm);
      PutAppIni(StatsMinUpdates,StatsMinutes->Text);
      PutAppIni(WorkSpaceColor,AnsiString(ColorBox->Color));
      if (AppMainForm->Color != ColorBox->Color)
          AppMainForm->Color  = ColorBox->Color;
      PutAppData("CustomColors",ColorDialog1->CustomColors);
      // editor
      PutAppIni(WordWrap,EdWrapWinBtn->Checked?"1":"0");
      PutAppIni(WordWrapShowBox,EdWrapShowBox->Checked?"1":"0");
      // sending mail
      PutAppIni(SendWrapChars,SendWrapCharBtn->Checked?"1":"0");
      int count = SendWrapCharEdit->Text.ToIntDef(0);
      PutAppIni(SendWrapCharsCount,count<16?16:count);
      PutAppIni(SendWrapWin,SendWrapWinBtn->Checked?"1":"0");
      PutAppIni(SendWrapNot,SendWrapNotBtn->Checked?"1":"0");
      // init
   }
}
*/
//---------------------------------------------------------------------------
void __fastcall TPreferForm::SendWrapBtnClick(TObject *Sender)
{
   bool enabled = SendWrapCharBtn->Checked;
   SendWrapCharEdit->Color = enabled ? clWindow:clBtnFace;
   SendWrapCharEdit->Enabled = enabled;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::SendWrapCharEditExit(TObject *Sender)
{
  if (SendWrapCharEdit->Text.ToIntDef(0)<16)
     SendWrapCharEdit->Text = "16";
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::StatsMinutesExit(TObject *Sender)
{
   if (StatsMinutes->Text.ToIntDef(-1)<0)
      StatsMinutes->Text = "0";
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ColorBtnClick(TObject *Sender)
{
   ColorDialog1->Color = AppMainForm->Color;
   if (ColorDialog1->Execute() && AppMainForm->Color!=ColorDialog1->Color)
   {
       ColorBox->Color = ColorDialog1->Color;
       ApplyColorBtn->Enabled = true;
   }
   else
       ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ApplyColorBtnClick(TObject *Sender)
{
   AppMainForm->Color = ColorBox->Color;
   ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
   ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::PageControl1Change(TObject *Sender)
{
   if (PageControl1->ActivePage==PgpSheet)
      ActiveControl = PgpPublicKeyring;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::BrowseImportClick(TObject *Sender)
{
   if (OpenImport->Execute())
      PgpImportKeyring->Text = OpenImport->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::BrowsePubringClick(TObject *Sender)
{
   if (OpenPubring->Execute())
      PgpPublicKeyring->Text = OpenPubring->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::BrowseSecringClick(TObject *Sender)
{
   if (OpenSecring->Execute())
      PgpSecretKeyring->Text = OpenSecring->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::PgpHelpBtnClick(TObject *Sender)
{
   OpenHelp("OptionsPgp","PGP Keyrings","",this);
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::PgpImportKeyringChange(TObject *Sender)
{
   ImportBtn->Enabled = FileExists(PgpImportKeyring->Text);
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ImportBtnClick(TObject *Sender)
{
   ImportPgpKeyrings(this);
}
//---------------------------------------------------------------------------
