//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "qspgpver.h"
#include "pgprecips.h"
#include "PgpPassEx.h"
#include "pgpfiles.h"
#include "global.h"
#include "fileman.h"
#include "headman.h"
#include "pgpdlg.h"
#include "MixmastDlg.h"
#include "pgp.h"

USERES("QSPGP.res");
USEUNIT("QSpgpVer.cpp");
USEFORM("PgpRecips.cpp", PgpRecipForm);
USEFORM("Wiper.cpp", WipeForm);
USEUNIT("pgp.cpp");
USEUNIT("Global.cpp");
USEUNIT("Mixmaster.cpp");
USEUNIT("Console.cpp");
USEUNIT("Fmxutils.cpp");
USEFORM("PGPpassEx.cpp", PgpPassForm);
USEUNIT("FileMan.cpp");
USEUNIT("HeadMan.cpp");
USEFORM("MixmastDlg.cpp", MixForm);
USEFORM("PgpDlg.cpp", PgpForm);
USEUNIT("PgpFiles.cpp");
USELIB("zlib.LIB");
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall PgpInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, TForm *MainForm, HWND AppHandle);
extern "C" __declspec(dllexport) char* __fastcall PgpSignMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptSignMessage(char *Message);
// returns only _new_ keys, not keys already in rem keyring
extern "C" __declspec(dllexport) char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc);
// returns new type1.list and saves new keyring in CRingTmp
extern "C" __declspec(dllexport) char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc);
extern "C" __declspec(dllexport) char* __fastcall PgpGetUserIdsKeyIds(char* KeyFile);
// gets individually armored keys
extern "C" __declspec(dllexport) char* __fastcall PgpArmorBlockToArmorKeys(char *keys);
extern "C" __declspec(dllexport) char* __fastcall PgpArmorKeysToArmorBlock(char *keys);
// import/replace pgp keys
extern "C" __declspec(dllexport) bool  __fastcall PgpImportKeysReplace(char *filename);
extern "C" __declspec(dllexport) bool  __fastcall PgpImportKeysAddNew(char *filename);
// init routines
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibVersion();
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibName();
// utility
bool __fastcall CutMessageAtCutmarks(TStrings *msg);
// string for returning char*s
char *retbuf=NULL;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
   ActMainForm=MainForm;
}
//---------------------------------------------------------------------------
bool __fastcall PgpImportKeysReplace(char *filename)
{
   //int bakcopies = STATSBAKCOPIES;
   AnsiString pubtmp="c:\\pub.pkr",sectmp="c:\\sec.skr";
   TPgpDb *newdb = new TPgpDb(filename,"");
   newdb->SaveToFile(pubtmp);
   newdb->SaveSecretToFile(sectmp);
//   FileSaveToFileBak(pubtmp,PgpPublicRing(),bakcopies);
//   FileSaveToFileBak(sectmp,PgpSecretRing(),bakcopies);
//   remove(pubtmp.c_str());
//   remove(sectmp.c_str());
   delete newdb;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall PgpImportKeysAddNew(char *filename)
{
   //int bakcopies = STATSBAKCOPIES;
   AnsiString pubtmp="c:\\pub.pkr",sectmp="c:\\sec.pkr";
   TPgpDb *curdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   TPgpDb *newdb = new TPgpDb(filename,"");
   TPgpKey *pub,*key=newdb->FirstKey();
   while (key)
   {
      if (!curdb->Find(key))
      {
         pub = new TPgpKey(key->Key);
         if (key->IsPair) pub->SecKey = new TPgpKey(key->SecKey->Key);
         curdb->AddKey(pub);
      }
   }
   curdb->SaveToFile(pubtmp);
   curdb->SaveSecretToFile(sectmp);
//   FileSaveToFileBak(pubtmp,PgpPublicRing(),bakcopies);
//   FileSaveToFileBak(sectmp,PgpSecretRing(),bakcopies);
//   remove(pubtmp.c_str());
//   remove(sectmp.c_str());
   delete newdb;
   delete curdb;
   return true;
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetUserIdsKeyIds(char *KeyFile)
{
   TPgpDb *pgpdb = new TPgpDb(KeyFile,"");
   if (pgpdb->error!=0)
   {
      delete pgpdb;
      return NULL;
   }

   TStringList *ids = new TStringList();
   TPgpKey *key = pgpdb->FirstKey();
   while (key)
   {
      for (int i=0; i<key->UserIds->Count; i++)
         ids->Add(key->IdText8+"="+key->UserIds->Strings[i]);
      key = key->Next;
   }
   if ((retbuf=new char[ids->Text.Length()+1])!=NULL)
      strcpy(retbuf,ids->Text.c_str());

   delete pgpdb;
   delete ids;
   return retbuf;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr)
{
   fromStr = fromStr.Trim();
   int p = fromStr.Pos(" ");
   AnsiString prm=fromStr.Trim().SubString(1,p-1);
   if (pos>0) return GetParamSpc(pos-1,fromStr.SubString(p,256));
   return prm;
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorKeysToArmorBlock(char *KeyBlocks)
{
   TStringList *keys = new TStringList(); keys->SetText(KeyBlocks);
   BUFFER *db=buf_new(),*bin=buf_new(),*armor=buf_new();
   if (retbuf) delete retbuf; retbuf = NULL;

   bool inkey=false;
   for (int i=0; i<keys->Count; i++)
   {
      AnsiString line = keys->Strings[i];
      if (line.Trim()=="-----BEGIN PGP PUBLIC KEY BLOCK-----") inkey = true;
      if (inkey) { line += "\r\n"; buf_appends(armor,line.c_str()); }
      if (line.Trim()=="-----END PGP PUBLIC KEY BLOCK-----")
      {
         pgp_dearmor(armor,bin);
         buf_cat(db,bin);
         buf_clear(armor);
         inkey = false;
      }
   }
   pgp_armor(db,2);
   if ((retbuf=new char[db->length+1])!=NULL)
      strcpy(retbuf,(char*)db->data);
   buf_free(armor);
   buf_free(bin);
   buf_free(db);
   delete keys;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeys(char *keyblock)
{
   AnsiString filename = CRingTmp;
   if (FileExists(filename)) DeleteFile(filename.c_str());
   TStringList *block = new TStringList();
   block->SetText(keyblock);
   block->SaveToFile(filename);
   delete block;
   if (retbuf) delete retbuf; retbuf = NULL;

   if (FileExists(filename))
   {
      TStringList *keys = new TStringList();
      TPgpDb *pgpdb = new TPgpDb(filename,"");
      TPgpKey *key = pgpdb->FirstKey();
      TStringList *akey = new TStringList();
      while (key)
      {
         BUFFER *armored = buf_new();
         buf_set(armored,key->Key);
         pgp_armor(armored,2);
         akey->SetText((char*)armored->data);
         if (akey->Count)
         {
            akey->Insert(0,key->Description+"\n");
            akey->Add("");
            keys->AddStrings(akey);
         }
         key = key->Next;
         akey->Clear();
      }
      DeleteFile(filename.c_str());
      if ((retbuf=new char[keys->Text.Length()+1])!=NULL)
         strcpy(retbuf,keys->Text.c_str());
      delete akey;
      delete pgpdb;
      delete keys;
   }
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc)
{ // this function respects 'disabled' remailers in type1.list
   AnsiString line,cringtxt=MixDir()+CRingTxt,ctyp1txt=MixDir()+CTyp1Txt;
   TStringList *dockeys = new TStringList();
   dockeys->SetText(KeyDoc);
   dockeys->SaveToFile(CRingTmp);
   delete dockeys;
   if (retbuf) delete retbuf; retbuf = NULL;

   TStringList *type1 = new TStringList();
   TStringList *newkeys = new TStringList();
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);

   TPgpDb *curdb = new TPgpDb(cringtxt,"");
   TPgpDb *newdb = new TPgpDb(CRingTmp,"");
   TPgpKey *key = newdb->FirstKey();
   while (key)
   {
      bool add=false;
      if (curdb->Find(key)<0)
      {
         add = true;
         for (int i=0; i<type1->Count; i++)
         {
            line = type1->Strings[i];
            if (line.Length() && line[1]=='#' && line.Pos(" 0x"+key->IdText8+" ")>=0)
            {
               add = false;
               break;
            }
         }
      }
      if (add) newkeys->Add(key->Description);
      key = key->Next;
   }

   if (FileExists(CRingTmp)) DeleteFile(CRingTmp.c_str());
   if ((retbuf=new char[newkeys->Text.Length()+1])!=NULL)
      strcpy(retbuf,newkeys->Text.c_str());
   delete newdb;
   delete curdb;
   delete type1;
   delete newkeys;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall CRingLineOk(AnsiString &line)
{
   return line.Pos("0x")>0;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpunkCaps(TStrings *rlist, AnsiString &shrtname)
{
   AnsiString caps,line,cap;
   for (int i=0; i<rlist->Count; i++)
   {
      line = rlist->Strings[i];
      if (line.Pos("$remailer{")==1)
      {
         line = GetParam(4,line,"=");
         int r=1; while (!(cap=GetParam(r,line," ")).IsEmpty())
            caps += " "+cap;
      }
   }
   return caps;
}
//---------------------------------------------------------------------------
char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc)
{
   if (retbuf) delete retbuf; retbuf = NULL;
   // newly downloaded pubring.asc
   AnsiString line,shrt,
      cringtxt=MixDir()+CRingTxt,ctyp1txt=MixDir()+CTyp1Txt,
      clisttxt=MixDir()+CListTxt;
   TStringList *dockeys = new TStringList();
   dockeys->SetText(KeyDoc);
   dockeys->SaveToFile(CRingTmp); // save as tmpring so not to replace pubring.asc
   delete dockeys;

   int i;
   if (!FileExists(cringtxt))
   {
      FILE *f = fopen(cringtxt.c_str(),"a+"); // create empty file
      fclose(f);
   }

   TStringList *type1 = new TStringList();
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);
   // open pubring.asc and tmpring.asc
   TPgpDb *curdb = new TPgpDb(cringtxt,"");
   TPgpDb *newdb = new TPgpDb(CRingTmp,"");
   TPgpKey *key = newdb->FirstKey();
   // cycle through tmpring looking for new keys;
   while (key)
   {
      bool add=false;
      if (!add && curdb->Find(key)<0) // <0 == newkey
      {
         add = true;
         for (i=0; i<type1->Count; i++)
         {
            line = type1->Strings[i];
            // check if this is a disabled key and flag
            if (line.Length() && line[1]=='#' && line.Pos(" 0x"+key->IdText8+" ")>=0)
            {
               add = false;
               break;
            }
         }
      }
      // add this key to the current database
      if (add) curdb->AddKey(new TPgpKey(key->Key));
      key = key->Next;
   }
   delete type1;

   BUFFER *buf = buf_new();
   key = curdb->FirstKey();
   while (key)
   {
      buf_cat(buf,key->Key);
      key = key->Next;
   }
   pgp_armor(buf,2);

   if ((retbuf = new char[buf->length+1])!=NULL)
      strcpy(retbuf,(char*)buf->data);

   buf_free(buf);
   delete curdb;
   delete newdb;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   AnsiString passphrase;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;
   if (retbuf) delete retbuf; retbuf = NULL;

   if (!PGPgetEncryptList(recips))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   bool cEncrypt = recips->Text==UseConventional+"\r\n";
   if (cEncrypt && !PGPgetConventionalPassphrase(passphrase,ActMainForm))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   CutMessageAtCutmarks(msg);
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(AppMainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete msg;
      return NULL;
   }
   // remove headers and hold for later
   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }

   int result=16; // just a non-error number
   if (mail->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      if (cEncrypt)
         result = Pgp->EncryptCMessage(mail,passphrase);
      else
         result = Pgp->EncryptMessage(mail,recips);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to encrypt!","QS PGP Encrypt Error",
         MB_OK);

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
   }
   delete mail;
   delete recips;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   AnsiString passphrase;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;
   if (retbuf) delete retbuf; retbuf = NULL;

   // get list of public keys
   if (!PGPgetEncryptList(recips,NotConventional))
   {
      delete recips;
      delete msg;
      return NULL;
   }
   // open keyrings for signing key
   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   if (pgpdb->error!=0)
   {
      delete pgpdb;
      delete recips;
      delete msg;
      return NULL;
   }
   TStringList *keys = new TStringList();
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;
   // fail job if no secret keys
   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   // pause
   Application->ProcessMessages(); Sleep(200);
   // keys ok, get sign key and passphrase
   int current=keys->IndexOf(keyid);
   int clearsign = GetAppIni(ClearSignMessage,"").ToIntDef(0);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,clearsign,ActMainForm))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   if (current>=0 && current<keys->Count)
      keyid = keys->Strings[current];
   // ok we have the key, parse it
   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last?last-(first-1):keyid.Length());
   // prepare message
   CutMessageAtCutmarks(msg);
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(AppMainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }

   int result=16; // just a non-error number
   if (mail->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      result = Pgp->EncryptSignMessage(mail,keyid,passphrase,recips,clearsign);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to sign!","PGP Error",MB_OK);

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
      PutAppIni(ClearSignMessage,clearsign?"1":"0");
   }
   delete mail;
   delete keys;
   delete recips;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   TStringList *recips = new TStringList();
   Headers->GetRecipsFull("To: ",recips);
   delete Headers;
   if (retbuf) delete retbuf; retbuf = NULL;

   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   if (pgpdb->error!=0)
   {
      delete recips;
      delete pgpdb;
      delete msg;
      return NULL;
   }

   TStringList *keys = new TStringList();
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;

   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete keys;
      delete recips;
      delete msg;
      return NULL;
   }

   AnsiString passphrase;
   int current=keys->IndexOf(keyid);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,2,ActMainForm))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (current>=0 && current<keys->Count)
      keyid = keys->Strings[current];
   // ok we have the key, parse it
   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last>=0?last-(first-1):keyid.Length());
   CutMessageAtCutmarks(msg);
   int result=16; // just a non-error number
   if (msg->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      Pgp->ToRemailer = Pgp->IsRemailed(recips); // to test for remailer address
      result = Pgp->SignMessage(msg,keyid,passphrase);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to sign!","PGP Sign Error",MB_OK);

   if (result==PGP_OK)
   {
      //msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
   }
   delete recips;
   delete keys;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   while (msg->Count && msg->Strings[msg->Count-1].IsEmpty())
      msg->Delete(msg->Count-1);
   return cut;
}
//---------------------------------------------------------------------------
/*bool __fastcall CListLineOk(AnsiString &line)
{
 //"redneck  config@redneck.gacracker.org     ###***##*###      :27 100.00%"
   int l=line.Length();
   AnsiString addr = GetParamSpc(1,line);
   bool ok = addr.Pos("@");
   if (ok) ok = l && line[l-10]==':';
   if (ok) ok = l && line[l-3]=='.';
   if (ok) ok = l && line[l]=='%';
   return ok;
}
//---------------------------------------------------------------------------
char* __fastcall GenerateType1List()
{
   char* nokeyfound="----------";
   AnsiString tmps,shrt,addr,caps,line,keyid,type1str,
      ctyp1txt=MixDir()+CTyp1Txt,clisttxt=MixDir()+CListTxt,
      cringtxt=MixDir()+CRingTxt;

   int d,t,r,i,p;
   TStringList *activ = new TStringList();
   TStringList *rlist = new TStringList();
   TStringList *type1 = new TStringList();
   TStringList *disab = new TStringList();
   // get disabled keys from type1.list
   if (FileExists(ctyp1txt)) disab->LoadFromFile(ctyp1txt);
   d=0; while (d<disab->Count)
   {
      if (disab->Strings[d].SubString(1,1)!="#") disab->Delete(d);
      else d++;
   }
   // start with the remailer stats report
   if (FileExists(clisttxt)) rlist->LoadFromFile(clisttxt);
   for (r=0; r<rlist->Count; r++)
   {
      line = rlist->Strings[r].Trim();
      if (line.Pos("$remailer{")==1) // get remailer def lines
      {
         shrt = GetParam(1,line,"\"");
         caps = GetParam(3,line,"\"");
         if ((p=caps.Pos("<"))==1) caps.Delete(p,1);
         if ((p=caps.Pos(">"))>0 ) caps.Delete(p,1);
         //addr = GetParam(0,caps," ");
         type1->Add(shrt+" "+caps);
      }
      else
      if (CListLineOk(line)) // get list of active remailers
      {
         activ->Add(GetParam(0,line," "));
      }
   }
   // dump all remailer defs not active in stats portion of list
   t=0; while (t<type1->Count)
   {
      if (activ->IndexOf(GetParam(0,type1->Strings[t]," "))<0) type1->Delete(t);
      else t++;
   }
   // get corresponding key id
   TStringList *keyids = new TStringList();
   keyids->SetText(PgpGetUserIdsKeyIds(cringtxt.c_str()));
   for (t=0; t<type1->Count; t++)
   {
      keyid = nokeyfound;
      type1str = type1->Strings[t];
      shrt = GetParam(0,type1str," ");
      addr = GetParam(1,type1str," ");
      for (i=0; i<keyids->Count; i++)
      {
         line = keyids->Strings[i];
         if (line.Pos(addr)>0)
         {
            keyid = "0x"+line.SubString(1,8);
            break;
         }
      }
      type1str = "";
      p=2; while (!(caps=GetParam(p,type1->Strings[t]," ")).IsEmpty())
      {
         type1str += " "+caps;
         p++;
      }
      type1->Strings[t] = shrt+" "+addr+" "+keyid+type1str;
   }
   delete keyids;
   // delete disableds in type1.list and add the actual disabled line
   for (d=0; d<disab->Count; d++)
   {
      line = disab->Strings[d].SubString(2,512);
      while ((t=type1->IndexOf(line))>=0)
         type1->Delete(t);
      type1->Add("#"+line);
   }
   // look for keys that did not have a key available
   TStringList *nokeys = new TStringList();
   for (t=0; t<type1->Count; t++)
   {
      line = type1->Strings[t];
      if (line.Pos(nokeyfound)>0 && line[1]!='#')
         nokeys->Add(GetParam(0,line," ")+" "+GetParam(1,line," "));
   }
   // inform the user of problem remailers
   if (nokeys->Count)
   {
      MsgBox(
         s("=================SOME PGP KEYS NOT FOUND=================\n")+
         s("\nYou have ")+s(nokeys->Count)+s(" remailers in your type1.list file that you do not have PGP keys\n")+
         s("for. Please have a look. You've got 3 options.\n\n")+
         s("1) If you updated your pubring.asc from the same source as your current\n")+
         s("rlist.txt, you will more than likely get that key. 2) You can leave them 'as is'.\n")+
         s("They won't be used, until a key is found, but I'll nag you with this dialog,\n")+
         s("after updates. 3) You can disable them with a pound sign '#' in front of those\n")+
         s("remailers in the type1.list file. In that case, I won't nag you, but I won't add\n")+
         s("those new keys when I find them, either.\n \n \n")+
         nokeys->Text+s("\n \n \n"),
         "TYPE1.LIST",
         MB_OK
      );
   }
   delete nokeys;

   AnsiString type1lines = type1->Text;
   delete disab;
   delete type1;
   delete activ;
   return type1lines.c_str();
}*/
//---------------------------------------------------------------------------


